<?php
namespace Teknisa\PED\Modules\Expedicao\Controllers;

use Teknisa\PED\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DataSource\ParameterBag;
use \Zeedhi\Framework\DataSource\DataSet;


use Teknisa\PED\Modules\Expedicao\Services\exp01100ParametrosExpedicaoService as exp01100ParametrosExpedicaoService;

class exp01100ParametrosExpedicaoController extends TeknisaCrud {
    
    protected $dataSourceName = 'parexpedicao_tipooperac';
    protected $environment;

    public function __construct($crudService, ParameterBag $parameterBag, exp01100ParametrosExpedicaoService $exp01100ParametrosExpedicaoService, $environment)
    {
        parent::__construct($crudService, $parameterBag);
        $this->exp01100ParametrosExpedicaoService = $exp01100ParametrosExpedicaoService;
        $this->environment = $environment;
    }
    
    public function deleteLogExpedicao($row, DTO\Response $response){
        try{
            $rows = $row->getRow();
            $cdfilial = $rows['CDFILIAL'];
            
            $this->exp01100ParametrosExpedicaoService->deleteLogExpedicao($cdfilial);

        }catch(\Exception $e){
            $response->setError(new DTO\Response\Error($e->getMessage()));
        }
    }   
    public function save(DTO\Request $request, DTO\Response $response){
        try{
            $this->dataSourceNameToSave = 'parexpedicao_tipooperac';
            $row = $request->getRow();
            $this->crudService->save($this->dataSourceNameToSave, [$row]);
        }catch(\Exception $e){
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }
}