<?php
namespace Teknisa\PED\Modules\Pedidos\Services;

use Teknisa\PED\Modules\Pedidos\Factories\ped00301PosicaoFactory;
use Zeedhi\Framework\DTO\Response\Error;

class ped00301PosicaoService {

    protected $factory;

	public function __construct($factory){
	    $this->ped00301PosicaoFactory = $factory;
	}

    public function returnPosicaoFinanceira($filtro) {
        try {
            $CDCLIENTE = $filtro[0]['CDCLIENTE'];
            $DTSINI = $filtro[1]['DTINI']; 
            $DTSFIM = $filtro[1]['DTFIM'];
            $DTTDATASAIDA = $filtro[1]['TDATA'];
            
            $result[0] = $this->ped00301PosicaoFactory->getPrimUltCompra($CDCLIENTE, $DTSINI, $DTTDATASAIDA, $DTSFIM);
            $result[1] = $this->ped00301PosicaoFactory->getTotalCompra($CDCLIENTE, $DTSINI, $DTTDATASAIDA, $DTSFIM);
            $result[2] = $this->ped00301PosicaoFactory->getMaiorCompra($CDCLIENTE, $DTSINI, $DTTDATASAIDA, $DTSFIM);
            $result[3] = $this->ped00301PosicaoFactory->getMaiorAtrasoPago($CDCLIENTE, $DTSINI, $DTTDATASAIDA, $DTSFIM);
            $result[4] = $this->ped00301PosicaoFactory->getMaiorAtrasoAberto($CDCLIENTE, $DTSINI, $DTTDATASAIDA, $DTSFIM);
            
            $posicao['CDCLIENTE'] = $CDCLIENTE;
            
            if($result[0]) {
                $posicao['CDCLIENTE'] = $result[0][0]['CDCLIENTE'];
                $posicao['NMRAZSOCCLIE'] = $result[0][0]['NMRAZSOCCLIE'];
                $posicao['PRIMCOMPRA'] = $result[0][0]['PRIMCOMPRA'];
                $posicao['PRIMDATA'] = $result[0][0]['PRIMDATA'];
                $posicao['ULTCOMPRA'] = $result[0][0]['ULTCOMPRA'];
                $posicao['ULTDATA'] = $result[0][0]['DTEMISSAO'];
                $posicao['TOTALCOMPRA'] = $result[0][0]['TOTALCOMPRA'];
            }
            
            if($result[1]) {
                $posicao['TOTCOMPAG'] = $result[1][0]['TOTCOMPAG'];
                $posicao['TOTATR'] = $result[1][0]['TOTATR'];
                $posicao['TOTVENC'] = $result[1][0]['TOTVENC'];
                $posicao['TOTAVENC'] = $result[1][0]['TOTAVENC'];
            }
            
            if($result[2]) {
                $posicao['MAIORDATA'] = $result[2][0]['MAIORDATA'];
                $posicao['MAIORVALOR'] = $result[2][0]['MAIORVALOR'];
            }
            
            if($result[3]) {
                $posicao['VRMATR'] = $result[3][0]['VRMATR'];
                $posicao['NRDIASATRASO'] = $result[3][0]['NRDIASATRASO'];   
            }
            
            if($result[4]) {
                $posicao['DTATRAB'] = $result[4][0]['DATA'];   
                $posicao['VRATRAB'] = $result[4][0]['VRATRAB'];   
            }
            
            //var_dump($posicao);
            return $posicao;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function returnContasAbertas($filtro) {
        $CDCLIENTE = $filtro[0]['CDCLIENTE'];
        $DTINICIAL = $filtro[1]['DTINI']; 
        $DTFINAL = $filtro[1]['DTFIM'];
        $TODOS = $filtro[1]['TDATA'];
        $CDFILIAL = $filtro[1]['CDFILIAL'];
        $result = $this->ped00301PosicaoFactory->getContaAberta($CDFILIAL,$CDCLIENTE, $DTINICIAL, $DTFINAL, $TODOS);
        return $result;
    }
    
    public function returnTipoRecAbertas($filtro) {
        $NRLANBOLREC = $filtro[0]['NRLANBOLREC'];
        $VRATUAREC = $filtro[0]['VRATUAREC'];
        $CDFILIAL = $filtro[1]['CDFILIAL']; 
        $result = $this->ped00301PosicaoFactory->getTipoRecAberta($NRLANBOLREC, $CDFILIAL, $VRATUAREC);
        return $result;
    }
    
    public function returnContasFechadas($filtro) {
        $CDCLIENTE = $filtro[0]['CDCLIENTE'];
        $DTINICIAL = $filtro[1]['DTINI']; 
        $DTFINAL = $filtro[1]['DTFIM'];
        $TODOS = $filtro[1]['TDATA'];
        $CDFILIAL = $filtro[1]['CDFILIAL'];
        $result = $this->ped00301PosicaoFactory->getContaFechada($CDFILIAL, $CDCLIENTE, $DTINICIAL, $DTFINAL, $TODOS);
        return $result;
    }
    
    public function returnTipoRecFechadas($filtro) {
        $NRLANBOLREC = $filtro[0]['NRLANBOLREC'];
        $VRATUAREC = $filtro[0]['VRATUAREC'];
        $CDFILIAL = $filtro[1]['CDFILIAL']; 
        $result = $this->ped00301PosicaoFactory->getTipoRecFechada($NRLANBOLREC, $CDFILIAL, $VRATUAREC);
        return $result;
    }
    
    public function returnEndereco($filtro) {
        $CDCLIENTE = $filtro[0]['CDCLIENTE'];
        $IDTPENDECLIE = $filtro[1]['TPENDERECO'];
        $result = $this->ped00301PosicaoFactory->getEndereco($CDCLIENTE, $IDTPENDECLIE);
        return $result;
    }
    
    public function returnHistorico($filtro) {
        $CDCLIENTE = $filtro[0]['CDCLIENTE'];
        $CDFILIAL = $filtro[1]['CDFILIAL']; 
        $DTINI = $filtro[1]['DTINI']; 
        $DTFIM = $filtro[1]['DTFIM'];
        $TDATA = $filtro[1]['TDATA'];
        $result = $this->ped00301PosicaoFactory->getHistorico($CDCLIENTE, $CDFILIAL, $DTINI, $DTFIM, $TDATA);
        return $result;
    }
    
    public function returnHistContas($filtro) {
        $CDCLIENTE = $filtro[0]['CDCLIENTE'];
        $CDFILIAL = $filtro[1]['CDFILIAL']; 
        $DTINI = $filtro[1]['DTINI']; 
        $DTFIM = $filtro[1]['DTFIM'];
        $TDATA = $filtro[1]['TDATA'];
        $result = $this->ped00301PosicaoFactory->getHistContas($CDCLIENTE, $CDFILIAL, $DTINI, $DTFIM, $TDATA);
        return $result;
    }
}


?>