/* Sistemas Integrados TEKNISA
  Gerao IN86 em Tabelas

Nome: 0010_SDXSTP0_EXPORTA_IN86.SQL

@C:\Web_560\sql\end_conv\oracle\clientes\sdx\0010_SDXSTPO_EXPORTA_IN86.SQL

Descrio:
Rotina para gerao IN86 em tabelas.

P_CDFILIAL    - Cdigo da filial a ser gerado a IN86.
P_DTINIRET    - Primeiro dia do ms da data de processamento da filial
P_DTFINRET    - ltimo dia do ms da data de processamento da filial
P_DATAINI     - Data de processamento da filial
P_DATAFIN     - Data de processamento da filial
P_DATAPROC    - Data de processamento da filial
P_DATAPOS     - Data de processamento da filial
P_TOTNIVEL    - Total de nveis da rvore de produtos
P_NUMEMOVI    - Prximo nmero referente a movimentao de estoque
P_ARQUIVO     - Arquivo a ser gerado (Dados Mestres de ECF - Sadas/Dados de Itens de ECF - Sadas/Dados de Detalhe/Resumo do cupom ECF
                Controle de Estoque - Lanamentos/Registro de Inventrio/Cadastro de Materiais
P_EXPCADMAT   - Exporta todo o cadastro de materiais (produtos)
P_EXPMANUAL   - Exportao manual (Sim ou No)

PARA DEBUGAR
raise_application_error(-20501, '' , True);

Criao:
28/01/2009 - Fabrcio Marcelo da Silva
*/

CREATE OR REPLACE PROCEDURE EXPORTA_IN86
   (P_CDFILIAL      IN FILIAL.CDFILIAL%TYPE,
    P_DTINIRET      IN DATE,
    P_DTFINRET      IN DATE,
    P_DATAINI       IN DATE,
    P_DATAFIN       IN DATE,
    P_DATAPROC      IN DATE,
    P_DATAPOS       IN DATE,
    P_TOTNIVEL      IN VARCHAR,
    P_NUMEMOVI      IN RELAT_MOVIEST.NRRELATMOVI%TYPE,
    P_ARQUIVO       IN EXPAUTFILIAL.CDRELATEXP%TYPE,
    P_EXPCADMAT     IN FILIAL.IDFILCENTPME%TYPE,
    P_EXPMANUAL     IN FILIAL.IDFILCENTPME%TYPE
   ) IS
   V_TRUNCTAB    CHAR(1);
   V_CDFISCOPER  VARCHAR2(04);

   V_CST1DIGT    VARCHAR2(01);
   V_CDCSTPROD   VARCHAR2(02);

   /* Dados Mestres de ECF - Sadas */
   CURSOR C_ARQ_ECFM IS
      SELECT RPAD(NVL(FI.CDEMPRESAP, ' '),9, ' ') AS CDEMPRSAP,
             RPAD(NVL(FI.CDFILIAL, ' '),9, ' ') AS CDFILIAL,
             RPAD(NVL(TO_CHAR(TO_NUMBER(RZ.NRECFREDZ)),' '),6) AS NRECFREDZ,
             RZ.DTREDUCAOZ,
             RPAD(NVL(USR_MAPARESUMO(RZ.CDFILIAL, RZ.CDCAIXA, RZ.DTREDUCAOZ),' '),10, ' ') AS CDMAPRESUMO,
             RPAD(NVL(TO_CHAR(TO_NUMBER(RZ.NRPRIMCFREDZ)),' '),6) AS NRPRIMCFREDZ,
             RPAD(NVL(TO_CHAR(TO_NUMBER(RZ.NRULTCFREDZ)),' '),6) AS NRULTCFREDZ,
             ROUND(ABS(NVL(RZ.VRGTREDZ,0) - NVL(RZ.VRVENBRUREDZ,0)),2) AS VRREDZ,
             ROUND(ABS(NVL(RZ.VRGTREDZ,0)),2) AS VRGRTOTAL,
             LTRIM(TO_CHAR(TO_NUMBER(RZ.NRREDREDZ),'000000')) AS NRREDREDZ,
             SUBSTR(LPAD(NVL(RZ.NRREINIREDZ,' '), 10, ' '),5,6) AS NRREINIREDZ,
             RPAD('TEC_WIN',150,' ') AS DSTEC_WIN,
             RPAD(TO_CHAR(TO_DATE(P_DATAPROC),'DDMMYYYY'),150,' ') AS DTPROC,
             RPAD(' ',150, ' ') AS DSESPACO1,
             RPAD(' ',150, ' ') AS DSESPACO2,
             RPAD(' ',150, ' ') AS DSESPACO3,
             '00000000000000000' AS DSSEQZERO1,
             '00000000000000000' AS DSSEQZERO2,
             '00000000000000000' AS DSSEQZERO3,
             LTRIM(TO_CHAR(TO_NUMBER(RZ.NRREDREDZ),'000000')) AS NRCUPOMFISC,
             RPAD(NVL(RZ.NRSERIEREDZ, ' '), 30, ' ') AS NRSERIEREDZ,
             SP.NRSERIEIMPR,
             SP.NRECFIMPR,
             SP.DSMODEIMPR,
             ROUND((RZ.VRGTREDZ - RZ.VRVENBRUREDZ), 2) AS VLR_GT_INI,
             ROUND(RZ.VRVENLIQREDZ,2) AS VLR_VENDA_LIQ
        FROM REDUCAOZ RZ, FILIAL FI, SDX_PARAMIMPR SP
       WHERE (RZ.CDFILIAL = P_CDFILIAL)
         AND (RZ.DTREDUCAOZ BETWEEN P_DATAINI AND P_DATAFIN)
         AND (FI.CDFILIAL = RZ.CDFILIAL)
         AND (RZ.CDFILIAL = SP.CDFILIAL(+))
         AND (RZ.CDCAIXA  = SP.CDCAIXA(+))
       ORDER BY FI.CDEMPRESAP, FI.CDFILIAL, RZ.NRECFREDZ, RZ.DTREDUCAOZ;
   /* Dados de Itens de ECF - Sadas */
   CURSOR C_ARQ_ECFI IS
      SELECT RPAD(NVL(CDEMPRESAP, ' '),9, ' ') AS CDEMPRSAP,
             RPAD(NVL(CDFILIAL, ' '), 9, ' ') AS CDFILIAL,
             RPAD(NVL(NRMAQREG, ' '),6, ' ') AS NRECFREDZ,
             DTREDUCAOZ,
             RPAD(LTRIM(SITUTRIB),4, ' ') AS VRSITUTRIB,
				 DECODE(SITUTRIB, 'CANC', '5949  ', DECODE(SITUTRIB,'F','5405  ','5102  ')) AS DSSITUTRIB,
             ROUND(ABS(NVL(VRACUMULADO,0)),2) AS VRACUMULADO,
             ROUND(ABS(NVL(VRBASECALC,0)),2) AS VRBASECALC,
             ROUND(ABS(NVL(VRCONTABIL,0)),2) AS VRCONTABIL,
             RPAD('TEC_WIN',150, ' ') AS DSTEC_WIN,
             RPAD(TO_CHAR(TO_DATE(P_DATAPROC),'DDMMYYYY'),150, ' ') AS DTPROC,
             RPAD(' ',150, ' ') AS DSESPACO1,
             RPAD(' ',150, ' ') AS DSESPACO2,
             RPAD(' ',150, ' ') AS DSESPACO3,
             '00000000000000000' AS DSSEQZERO1,
             '00000000000000000' AS DSSEQZERO2,
             '00000000000000000' AS DSSEQZERO3,
             NRCUPOMFISC
        FROM (SELECT FI.CDEMPRESAP, IP.CDFILIAL, TO_CHAR(TO_NUMBER(IP.NRECFREDZ)) AS NRMAQREG,
                     IP.DTREDUCAOZ, TO_CHAR(DECODE(IP.VRALIQIMPRZ,0.00, 0, (IP.VRALIQIMPRZ*100)),'0000') AS SITUTRIB,
                     SUM(IP.VRIMPOSTORZ) VRACUMULADO, SUM(IP.VRBCALCIMPRZ) AS VRBASECALC, SUM(IP.VRBCALCIMPRZ) AS VRCONTABIL,
                     LTRIM(TO_CHAR(TO_NUMBER(RZ.NRULTCFREDZ),'000000')) AS NRCUPOMFISC
                FROM IMPOSTOREDZ IP, FILIAL FI, IMPOSTO I, REDUCAOZ RZ
               WHERE (IP.CDFILIAL = P_CDFILIAL)
                 AND (IP.DTREDUCAOZ BETWEEN P_DATAINI AND P_DATAFIN)
                 AND (IP.CDIMPOSTO = I.CDIMPOSTO)
                 AND (I.IDTPIMPOSFIS = 'T')
                 AND (IP.VRIMPOSTORZ > 0)
                 AND (IP.CDFILIAL = FI.CDFILIAL)
                 AND (IP.CDFILIAL = RZ.CDFILIAL)
                 AND (IP.CDCAIXA = RZ.CDCAIXA)
                 AND (IP.NRECFREDZ = RZ.NRECFREDZ)
                 AND (IP.DTREDUCAOZ = RZ.DTREDUCAOZ)
               GROUP BY FI.CDEMPRESAP, IP.CDFILIAL, TO_CHAR(TO_NUMBER(IP.NRECFREDZ)),
                        IP.DTREDUCAOZ, IP.VRALIQIMPRZ, RZ.NRULTCFREDZ
               UNION ALL
              SELECT FI.CDEMPRESAP, RZ.CDFILIAL, TO_CHAR(TO_NUMBER(RZ.NRECFREDZ)) AS NRMAQREG,
                     RZ.DTREDUCAOZ, 'F' AS SITUTRIB, SUM(RZ.VRSTRIBREDZ) VRACUMULADO,
                     SUM(RZ.VRSTRIBREDZ) AS VRBASECALC, SUM(RZ.VRSTRIBREDZ) AS VRCONTABIL,
                     LTRIM(TO_CHAR(TO_NUMBER(RZ.NRULTCFREDZ),'000000')) AS NRCUPOMFISC
                FROM REDUCAOZ RZ, FILIAL FI
               WHERE (RZ.CDFILIAL = P_CDFILIAL)
                 AND (RZ.DTREDUCAOZ BETWEEN P_DATAINI AND P_DATAFIN)
                 AND (RZ.VRSTRIBREDZ > 0)
                 AND (RZ.CDFILIAL = FI.CDFILIAL)
               GROUP BY FI.CDEMPRESAP, RZ.CDFILIAL, TO_CHAR(TO_NUMBER(RZ.NRECFREDZ)),
                        RZ.DTREDUCAOZ, RZ.NRULTCFREDZ
               UNION ALL
              SELECT FI.CDEMPRESAP, RZ.CDFILIAL, TO_CHAR(TO_NUMBER(RZ.NRECFREDZ)) AS NRMAQREG,
                     RZ.DTREDUCAOZ, 'I' AS SITUTRIB, SUM(RZ.VRISENCREDZ) AS VRACUMULADO,
                     0.00 AS VRBASECALC, SUM(RZ.VRISENCREDZ) AS VRCONTABIL,
                     LTRIM(TO_CHAR(TO_NUMBER(RZ.NRULTCFREDZ),'000000')) AS NRCUPOMFISC
                FROM REDUCAOZ RZ, FILIAL FI
               WHERE (RZ.CDFILIAL = P_CDFILIAL)
                 AND (RZ.DTREDUCAOZ BETWEEN P_DATAINI AND P_DATAFIN)
                 AND (RZ.VRISENCREDZ > 0 )
                 AND (RZ.CDFILIAL = FI.CDFILIAL)
               GROUP BY FI.CDEMPRESAP, RZ.CDFILIAL, TO_CHAR(TO_NUMBER(RZ.NRECFREDZ)),
                        RZ.DTREDUCAOZ, RZ.NRULTCFREDZ
               UNION ALL
              SELECT FI.CDEMPRESAP, RZ.CDFILIAL, TO_CHAR(TO_NUMBER(RZ.NRECFREDZ)) AS NRMAQREG,
                     RZ.DTREDUCAOZ, 'N' AS SITUTRIB, SUM(RZ.VRNINCIDREDZ) AS VRACUMULADO,
                     0.00 AS VRBASECALC, SUM(RZ.VRNINCIDREDZ) AS VRCONTABIL,
                     LTRIM(TO_CHAR(TO_NUMBER(RZ.NRULTCFREDZ),'000000')) AS NRCUPOMFISC
                FROM REDUCAOZ RZ, FILIAL FI
               WHERE (RZ.CDFILIAL = P_CDFILIAL)
                 AND (RZ.DTREDUCAOZ BETWEEN P_DATAINI AND P_DATAFIN)
                 AND (RZ.VRNINCIDREDZ > 0 )
                 AND (RZ.CDFILIAL = FI.CDFILIAL)
               GROUP BY FI.CDEMPRESAP, RZ.CDFILIAL, TO_CHAR(TO_NUMBER(RZ.NRECFREDZ)),
                        RZ.DTREDUCAOZ, RZ.NRULTCFREDZ
               UNION ALL
              SELECT FI.CDEMPRESAP, RZ.CDFILIAL, TO_CHAR(TO_NUMBER(RZ.NRECFREDZ)) AS NRMAQREG,
                     RZ.DTREDUCAOZ, 'CANC' AS SITUTRIB, SUM(RZ.VRTOTCANREDZ) AS VRACUMULADO,
                     0.00 AS VRBASECALC, 0.00 AS VRCONTABIL,
                     LTRIM(TO_CHAR(TO_NUMBER(RZ.NRULTCFREDZ),'000000')) AS NRCUPOMFISC
                FROM REDUCAOZ RZ, FILIAL FI
               WHERE (RZ.CDFILIAL = P_CDFILIAL)
                 AND (RZ.DTREDUCAOZ BETWEEN P_DATAINI AND P_DATAFIN)
                 AND (RZ.VRTOTCANREDZ > 0)
                 AND (RZ.CDFILIAL = FI.CDFILIAL)
               GROUP BY FI.CDEMPRESAP, RZ.CDFILIAL, TO_CHAR(TO_NUMBER(RZ.NRECFREDZ)),
                        RZ.DTREDUCAOZ, RZ.NRULTCFREDZ
               UNION ALL
              SELECT FI.CDEMPRESAP, RZ.CDFILIAL, TO_CHAR(TO_NUMBER(RZ.NRECFREDZ)) AS NRMAQREG,
                     RZ.DTREDUCAOZ, 'DESC' AS SITUTRIB, SUM(RZ.VRTOTDESREDZ) AS VRACUMULADO,
                     0.00 AS VRBASECALC, 0.00 AS VRCONTABIL,
                     LTRIM(TO_CHAR(TO_NUMBER(RZ.NRULTCFREDZ),'000000')) AS NRCUPOMFISC
                FROM REDUCAOZ RZ, FILIAL FI
               WHERE (RZ.CDFILIAL = P_CDFILIAL)
                 AND (RZ.DTREDUCAOZ BETWEEN P_DATAINI AND P_DATAFIN)
                 AND (RZ.VRTOTDESREDZ > 0)
                 AND (RZ.CDFILIAL = FI.CDFILIAL)
               GROUP BY FI.CDEMPRESAP, RZ.CDFILIAL, TO_CHAR(TO_NUMBER(RZ.NRECFREDZ)),
                        RZ.DTREDUCAOZ, RZ.NRULTCFREDZ
               UNION ALL
              SELECT FI.CDEMPRESAP, IP.CDFILIAL, TO_CHAR(TO_NUMBER(IP.NRECFREDZ)) AS NRMAQREG,
                     IP.DTREDUCAOZ, 'ISS' AS SITUTRIB,
                     SUM(IP.VRIMPOSTORZ) VRACUMULADO, SUM(IP.VRBCALCIMPRZ) AS VRBASECALC, SUM(IP.VRBCALCIMPRZ) AS VRCONTABIL,
                     LTRIM(TO_CHAR(TO_NUMBER(RZ.NRULTCFREDZ),'000000')) AS NRCUPOMFISC
                FROM IMPOSTOREDZ IP, FILIAL FI, IMPOSTO I, REDUCAOZ RZ
               WHERE (IP.CDFILIAL = P_CDFILIAL)
                 AND (IP.DTREDUCAOZ BETWEEN P_DATAINI AND P_DATAFIN)
                 AND (IP.VRBCALCIMPRZ > 0)
                 AND (IP.CDIMPOSTO = I.CDIMPOSTO)
                 AND (I.IDTPIMPOSFIS = 'I')
                 AND (IP.CDFILIAL = FI.CDFILIAL)
                 AND (IP.CDFILIAL = RZ.CDFILIAL)
                 AND (IP.CDCAIXA = RZ.CDCAIXA)
                 AND (IP.NRECFREDZ = RZ.NRECFREDZ)
                 AND (IP.DTREDUCAOZ = RZ.DTREDUCAOZ)
               GROUP BY FI.CDEMPRESAP, IP.CDFILIAL, TO_CHAR(TO_NUMBER(IP.NRECFREDZ)),
                        IP.DTREDUCAOZ, IP.VRALIQIMPRZ, RZ.NRULTCFREDZ
               ORDER BY 1, 2, 3, 4) ECFI;
   /* Dados de Detalhe/Resumo do cupom ECF */
   CURSOR C_ARQ_ECFR IS
      SELECT RPAD(NVL(CDEMPRESAP,' '), 9, ' ') AS CDEMPRSAP,
             RPAD(NVL(CDFILIAL,' '), 9,' ') AS CDFILIAL,
             DTENTRVENDA,
             RPAD(NVL(NRSERFABECF,' '), 20,' ') AS NMCAIXA,
             RPAD(NVL(NRMAQREG,' '), 6, ' ') AS NRECFREDZ,
             RPAD(NVL(SUBSTR(NRCUPOMFIS,1,6),'000001'), 6, ' ') AS NRCUPOMFISC,
             NRSEQUITVEND AS NRSEQUITVEND,
             LTRIM(VRSITUTRIB) AS IDTPIMPOSFIS,
             'D' AS VRFIXO1,
             '2C ' AS VRFIXO2,
             RPAD(NVL(CDPRODUTO, ' '), 20, ' ') AS CDMATERIAL,
             ROUND(ABS(NVL(QTPRODVEND,0)),3) AS QTPRODVEND,
             ROUND(ABS(NVL(VRUNIT,0)),3) AS VRUNITARIO,
             ROUND(ABS(NVL(BASECALC,0)),2) AS VRBASECALC,
             ROUND(ABS(NVL(VRIMPOSTO,0)),2) AS VRIMPOSTO,
             RPAD('TEC_WIN',150, ' ') AS DSTEC_WIN,
             RPAD(TO_CHAR(TO_DATE(P_DATAPROC),'DDMMYYYY'),150,' ') AS DTPROC,
             RPAD(' ',150,' ') AS DSESPACO1,
             RPAD(' ',150,' ') AS DSESPACO2,
             RPAD(' ',150,' ') AS DSESPACO3,
             '00000000000000000' AS DSSEQZERO1,
             '00000000000000000' AS DSSEQZERO2,
             '00000000000000000' AS DSSEQZERO3,
             NMCLIENTE,
             NRCPFCLIE,
             VRCUPOCANC,
             VRITEMCANC,
             IDITEMCANC,
             CDPRODUTO AS CDARVPROD,
             CDFILIAL AS CDFILIVENDA
        FROM (SELECT /*+ NO_MERGE(RZ) ORDERED */
                     FI.CDEMPRESAP, FI.CDFILIAL, VD.DTENTRVENDA , SUBSTR(CA.NMCAIXA,1,20) AS NRSERFABECF,
                     RZ.NRMAQREG,  VD.NRCUPOMFIS,
                     IT.NRSEQUITVEND, DECODE(I.IDTPIMPOSFIS, 'T',TO_CHAR((II.VRPEALPRODIT * 100),'0000'),RPAD(I.IDTPIMPOSFIS,4,' '))AS VRSITUTRIB,
                     PD.CDARVPROD AS CDPRODUTO, IT.QTPRODVEND, (IT.VRUNITVEND+VRUNITVENDCL) AS VRUNIT,
                     (IT.QTPRODVEND * ((IT.VRUNITVEND+IT.VRUNITVENDCL)-IT.VRDESITVEND)) AS BASECALC,
                     ((IT.QTPRODVEND * ((IT.VRUNITVEND+IT.VRUNITVENDCL)-IT.VRDESITVEND) * (II.VRPEALPRODIT/100))) AS VRIMPOSTO,
                     DECODE(NVL(VD.CDCONSUMIDOR,'A'), 'A', 'CONSUMIDOR', CL.NMCONSUMIDOR) AS NMCLIENTE,
                     DECODE(NVL(VD.CDCONSUMIDOR,'A'), 'A', ' ',
                     DECODE(LENGTH(REPLACE(NVL(REPLACE(REPLACE(REPLACE(VD.NRINSCRCONS,'/',''),'-',''),'.',''),' '),',','')), '11',
                            REPLACE(NVL(REPLACE(REPLACE(REPLACE(VD.NRINSCRCONS,'/',''),'-',''),'.',''),' '),',',''),
                            DECODE(LENGTH(REPLACE(NVL(REPLACE(REPLACE(REPLACE(VD.NRINSCRCONS,'/',''),'-',''),'.',''),' '),',','')), '14',
                                   REPLACE(NVL(REPLACE(REPLACE(REPLACE(VD.NRINSCRCONS,'/',''),'-',''),'.',''),' '),',',''),' '))) AS NRCPFCLIE,
                     0 AS VRCUPOCANC,
                     0 AS VRITEMCANC,
                     'N' AS IDITEMCANC
                FROM VENDA VD, FILIAL FI, CAIXA CA, ITEMVENDA IT, PRODUTO PD, ITVENDAIMPOS II, IMPOSTO I, CONSUMIDOR CL,
                     (SELECT CDFILIAL, CDCAIXA, DTREDUCAOZ, MAX(TO_CHAR(TO_NUMBER(NRECFREDZ))) AS NRMAQREG
                        FROM REDUCAOZ
                       WHERE CDFILIAL = P_CDFILIAL
                         AND DTREDUCAOZ BETWEEN P_DATAINI AND P_DATAFIN
                       GROUP BY CDFILIAL, CDCAIXA, DTREDUCAOZ) RZ
               WHERE VD.CDFILIAL = P_CDFILIAL
                 AND VD.DTENTRVENDA BETWEEN P_DATAINI AND P_DATAFIN
                 AND VD.IDSITUVENDA = 'O'
                 AND VD.CDCLIENTE = CL.CDCLIENTE(+)
                 AND VD.CDCONSUMIDOR = CL.CDCONSUMIDOR(+)
                 AND VD.CDFILIAL = FI.CDFILIAL
                 AND VD.CDFILIAL = CA.CDFILIAL
                 AND VD.CDCAIXA = CA.CDCAIXA
                 AND VD.CDFILIAL = RZ.CDFILIAL
                 AND VD.CDCAIXA = RZ.CDCAIXA
                 AND VD.DTENTRVENDA = RZ.DTREDUCAOZ
                 AND VD.CDFILIAL = IT.CDFILIAL
                 AND VD.CDCAIXA = IT.CDCAIXA
                 AND VD.NRSEQVENDA = IT.NRSEQVENDA
                 AND IT.CDFILIAL = II.CDFILIAL
                 AND IT.CDCAIXA = II.CDCAIXA
                 AND IT.NRSEQVENDA = II.NRSEQVENDA
                 AND IT.NRSEQUITVEND = II.NRSEQUITVEND
                 AND II.CDIMPOSTO = I.CDIMPOSTO
                 AND IT.CDPRODUTO = PD.CDPRODUTO
                 AND VD.CDFILIAL||VD.CDCAIXA||VD.NRSEQVENDA IN (SELECT MO.CDFILIAL||MO.CDCAIXA||MO.NRSEQVENDA
                                                                  FROM MOVCAIXA MO
                                                                 WHERE MO.CDFILIAL = VD.CDFILIAL
                                                                   AND MO.CDCAIXA = VD.CDCAIXA
                                                                   AND MO.DTMOVIMCAIXA = VD.DTENTRVENDA
                                                                   AND MO.IDTIPOMOVIVE IN ('E','T','S'))
        		   UNION ALL
        		  SELECT /*+ NO_MERGE(RZ) ORDERED */
                     FI.CDEMPRESAP, FI.CDFILIAL, VD.DTENTRVENDA , SUBSTR(CA.NMCAIXA,1,20) AS NRSERFABECF,
                     RZ.NRMAQREG,  VD.NRCUPOMFIS,
                     IT.NRSEQUITVEND, DECODE(I.IDTPIMPOSFIS, 'T',TO_CHAR((II.VRPEALPRODIT * 100),'0000'),RPAD(NVL(I.IDTPIMPOSFIS, ' '),4,' '))AS VRSITUTRIB,
                     PD.CDARVPROD AS CDPRODUTO, IT.QTPRODVEND, (IT.VRUNITVEND+VRUNITVENDCL) AS VRUNIT,
                     (IT.QTPRODVEND * ((IT.VRUNITVEND+IT.VRUNITVENDCL)-IT.VRDESITVEND)) AS BASECALC,
                     DECODE(II.VRPEALPRODIT, NULL, 0, ((IT.QTPRODVEND * ((IT.VRUNITVEND+IT.VRUNITVENDCL)-IT.VRDESITVEND) * (II.VRPEALPRODIT/100)))) AS 			VRIMPOSTO,
                     DECODE(NVL(VD.CDCONSUMIDOR,'A'), 'A', 'CONSUMIDOR', CL.NMCONSUMIDOR) AS NMCLIENTE,
                     DECODE(NVL(VD.CDCONSUMIDOR,'A'), 'A', ' ',
                     DECODE(LENGTH(REPLACE(NVL(REPLACE(REPLACE(REPLACE(VD.NRINSCRCONS,'/',''),'-',''),'.',''),' '),',','')), '11',
                            REPLACE(NVL(REPLACE(REPLACE(REPLACE(VD.NRINSCRCONS,'/',''),'-',''),'.',''),' '),',',''),
                            DECODE(LENGTH(REPLACE(NVL(REPLACE(REPLACE(REPLACE(VD.NRINSCRCONS,'/',''),'-',''),'.',''),' '),',','')), '14',
                                   REPLACE(NVL(REPLACE(REPLACE(REPLACE(VD.NRINSCRCONS,'/',''),'-',''),'.',''),' '),',',''),' '))) AS NRCPFCLIE,
                    (SELECT ROUND(SUM(VRUNITVEND*QTPRODVEND),2) AS VRCUPOCANC
                       FROM ITEMVENDA V
                      WHERE IT.CDFILIAL = V.CDFILIAL
                        AND IT.CDCAIXA = V.CDCAIXA
                        AND IT.NRSEQVENDA = V.NRSEQVENDA
                        AND IT.NRSEQUITVEND = V.NRSEQUITVEND) AS VRCUPOCANC,
                     ROUND(DECODE(VD.IDSITUVENDA,'C', ((IT.QTPRODVEND * (IT.VRUNITVEND+IT.VRUNITVENDCL))-IT.VRDESITVEND),0),2) AS VRITEMCANC,
                     'S' AS IDITEMCANC
                FROM VENDA VD, FILIAL FI, CAIXA CA, ITEMVENDA IT, PRODUTO PD, ITVENDAIMPOS II, IMPOSTO I, CONSUMIDOR CL,
                     (SELECT CDFILIAL, CDCAIXA, DTREDUCAOZ, MAX(TO_CHAR(TO_NUMBER(NRECFREDZ))) AS NRMAQREG
                        FROM REDUCAOZ
                       WHERE CDFILIAL = P_CDFILIAL
                         AND DTREDUCAOZ BETWEEN P_DATAINI AND P_DATAFIN
                       GROUP BY CDFILIAL, CDCAIXA, DTREDUCAOZ) RZ
               WHERE VD.CDFILIAL = P_CDFILIAL
                 AND VD.DTENTRVENDA BETWEEN P_DATAINI AND P_DATAFIN
                 AND VD.IDSITUVENDA = 'C'
                 AND VD.CDCLIENTE = CL.CDCLIENTE(+)
                 AND VD.CDCONSUMIDOR = CL.CDCONSUMIDOR(+)
                 AND VD.CDFILIAL = FI.CDFILIAL
                 AND VD.CDFILIAL = CA.CDFILIAL
                 AND VD.CDCAIXA = CA.CDCAIXA
                 AND VD.CDFILIAL = RZ.CDFILIAL
                 AND VD.CDCAIXA = RZ.CDCAIXA
                 AND VD.DTENTRVENDA = RZ.DTREDUCAOZ
                 AND VD.CDFILIAL = IT.CDFILIAL
                 AND VD.CDCAIXA = IT.CDCAIXA
                 AND VD.NRSEQVENDA = IT.NRSEQVENDA
                 AND IT.CDFILIAL = II.CDFILIAL (+)
                 AND IT.CDCAIXA = II.CDCAIXA (+)
                 AND IT.NRSEQVENDA = II.NRSEQVENDA (+)
                 AND IT.NRSEQUITVEND = II.NRSEQUITVEND (+)
                 AND II.CDIMPOSTO = I.CDIMPOSTO (+)
                 AND IT.CDPRODUTO = PD.CDPRODUTO
		         UNION ALL
              SELECT /*+ NO_MERGE(RZ) ORDERED */
                     FI.CDEMPRESAP, FI.CDFILIAL, VD.DTENTRVENDA , SUBSTR(CA.NMCAIXA,1,20) AS NRSERFABECF,
                     RZ.NRMAQREG,  VD.NRCUPOMFIS,
                     IT.NRSEQITVENDC, '0000' AS VRSITUTRIB,
                     PD.CDARVPROD AS CDPRODUTO, IT.QTPRODVENDC, (IT.VRUNITVENDC+VRUNITVENCLC) AS VRUNIT,
                     (IT.QTPRODVENDC * ((IT.VRUNITVENDC+IT.VRUNITVENCLC)-IT.VRDESITVENDC)) AS BASECALC,
                     0 AS VRIMPOSTO,
                     DECODE(NVL(VD.CDCONSUMIDOR,'A'), 'A', 'CONSUMIDOR', CL.NMCONSUMIDOR) AS NMCLIENTE,
                     DECODE(NVL(VD.CDCONSUMIDOR,'A'), 'A', ' ',
                     DECODE(LENGTH(REPLACE(NVL(REPLACE(REPLACE(REPLACE(VD.NRINSCRCONS,'/',''),'-',''),'.',''),' '),',','')), '11',
                            REPLACE(NVL(REPLACE(REPLACE(REPLACE(VD.NRINSCRCONS,'/',''),'-',''),'.',''),' '),',',''),
                            DECODE(LENGTH(REPLACE(NVL(REPLACE(REPLACE(REPLACE(VD.NRINSCRCONS,'/',''),'-',''),'.',''),' '),',','')), '14',
                                   REPLACE(NVL(REPLACE(REPLACE(REPLACE(VD.NRINSCRCONS,'/',''),'-',''),'.',''),' '),',',''),' '))) AS NRCPFCLIE,
                    (SELECT ROUND(SUM(VRUNITVENDC*QTPRODVENDC),2) AS VRCUPOCANC
                       FROM ITVENDACAN V
                      WHERE IT.CDFILIAL = V.CDFILIAL
                        AND IT.CDCAIXA = V.CDCAIXA
                        AND IT.NRSEQVENDA = V.NRSEQVENDA
                        AND IT.NRSEQITVENDC = V.NRSEQITVENDC) AS VRCUPOCANC,
                     ROUND(((IT.QTPRODVENDC * (IT.VRUNITVENDC+IT.VRUNITVENCLC))-IT.VRDESITVENDC),2) AS VRITEMCANC,
                     'S' AS IDITEMCANC
                FROM VENDA VD, FILIAL FI, CAIXA CA, ITVENDACAN IT, PRODUTO PD, CONSUMIDOR CL,
                     (SELECT CDFILIAL, CDCAIXA, DTREDUCAOZ, MAX(TO_CHAR(TO_NUMBER(NRECFREDZ))) AS NRMAQREG
                        FROM REDUCAOZ
                       WHERE CDFILIAL = P_CDFILIAL
                         AND DTREDUCAOZ BETWEEN P_DATAINI AND P_DATAFIN
                       GROUP BY CDFILIAL, CDCAIXA, DTREDUCAOZ) RZ
            	WHERE VD.CDFILIAL = P_CDFILIAL
                 AND VD.DTENTRVENDA BETWEEN P_DATAINI AND P_DATAFIN
                 AND VD.IDSITUVENDA IN ('C','O')
                 AND VD.CDCLIENTE = CL.CDCLIENTE(+)
                 AND VD.CDCONSUMIDOR = CL.CDCONSUMIDOR(+)
                 AND VD.CDFILIAL = FI.CDFILIAL
                 AND VD.CDFILIAL = CA.CDFILIAL
                 AND VD.CDCAIXA = CA.CDCAIXA
                 AND VD.CDFILIAL = RZ.CDFILIAL
                 AND VD.CDCAIXA = RZ.CDCAIXA
                 AND VD.DTENTRVENDA = RZ.DTREDUCAOZ
                 AND VD.CDFILIAL = IT.CDFILIAL
                 AND VD.CDCAIXA = IT.CDCAIXA
                 AND VD.NRSEQVENDA = IT.NRSEQVENDA
                 AND IT.CDPRODUTO = PD.CDPRODUTO);
   /* Controle de Estoque - Lanamentos */
   CURSOR C_ARQ_ESTL IS
      SELECT CDEMPRSAP,
             CDFILIAL,
             RPAD('MP', 5, ' ') AS CDMP,
             DTLANCAMENTO AS DTLANCAMENTO,
             CDMATERIAL AS CDMATERIAL,
             LPAD(TIPOOPERAC, 6, '0') AS CDTIPOOPER,
             QUANTIDADE AS QTPRODUTO,
             IDLANCAMENTO,
             RPAD(NRARQUIV, 40, ' ') AS NRSEQITPROD,
             TIPODOC AS CDTIPODOCU,
             NRDOC AS NRNOTAFISC,
             SERIEDOC AS CDSERIE,
             NRITNF,
             DSESPACO1,
             CATEGORIAPFPJ AS CDCATEGORIAPFPJ,
             CODIGOPFPJ AS CDPFPJ,
             '001' AS VRFIXO1,
             VRUNITARIO AS VRUNITPROD,
             VRTOTAL AS VRTOTAITEM,
             CUSTOUNIT AS VRCUSTOUNIT,
             CUSTOTOT AS VRCUSTOTOT,
             RPAD(LPAD(NVL(CONTAESTOQ, '0'),10,'0'), 28, ' ') AS CDCONTAESTOQ,
             RPAD(' ', 28, ' ') AS DSESPACO2,
             RPAD(' ', 14, ' ') AS DSESPACO3,
             CENTROCUSTO AS CDCENTCUST,
             CFOPITEM AS CDCFOPPROD,
             VRIPI AS VRIPIPROD,
             RPAD('0',  6, '0') AS VRFIXO2,
             RPAD(' ', 10, ' ') AS DSESPACO4,
             RPAD(' ', 10, ' ') AS DSESPACO5,
             RPAD(' ',  4, ' ') AS DSESPACO6,
             RPAD(' ',  4, ' ') AS DSESPACO7,
             RPAD(' ',  4, ' ') AS DSESPACO8,
             RPAD(' ',150, ' ') AS DSESPACO9,
             RPAD('TEC_WIN', 150, ' ') AS DSTEC_WIN,
             RPAD(TO_CHAR(TO_DATE(P_DATAPROC), 'ddmmyyyy'), 150, ' ') AS DTPROC,
             RPAD(' ',150, ' ') AS DSESPACO10,
             RPAD(' ',150, ' ') AS DSESPACO11,
             RPAD(' ',150, ' ') AS DSESPACO12,
             LTRIM(RPAD('0', 17, '0')) AS DSSEQZERO1,
             LTRIM(RPAD('0', 17, '0')) AS DSSEQZERO2,
             LTRIM(RPAD('0', 17, '0')) AS DSSEQZERO3,
             CSTITEM
        FROM (SELECT RPAD(NVL(FI.CDEMPRESAP, ' '), 9, ' ')        AS CDEMPRSAP,
                     RPAD(NVL(NF.CDFILIRECE, ' '), 9, ' ')        AS CDFILIAL,
                     RPAD(NVL(PD.CDNATUPROD, ' '), 5, ' ')        AS NATUREZA,
                     NF.DTENTRSAID AS DTLANCAMENTO,
                     RPAD(NVL(PD.CDPRODESTO, ' '), 20, ' ')        AS CDMATERIAL,
                     NVL(NF.CDTIPOOPER, ' ')        AS TIPOOPERAC,
                     ROUND((IT.QTITEMPROD * NVL(PD.VRFATOCONV,1)),3) AS QUANTIDADE,
                     'E'                                AS IDLANCAMENTO,
                     DECODE(NF.CDTIPOOPER, '09', 'VTE', DECODE(NF.CDTIPOOPER, '10', 'ESN', 'NFE')) AS TIPODOC,
                     RPAD(NVL(NF.NRNOTAFISC, ' '), 15, ' ')       AS NRDOC,
                     RPAD(NVL(NF.CDSERIEENTR, ' '), 5, ' ')       AS SERIEDOC,
                     RPAD(NVL(IT.NRSEQITPROD, ' '), 15,' ')       AS NRITNF,
                     DECODE(NF.IDORIGDESTNF, 'C', 'CL',
                            DECODE(NF.IDORIGDESTNF, 'F', 'FO', 'FO')) AS CATEGORIAPFPJ,
                     RPAD(NVL(DECODE(NF.IDTPIJURNF, 'I',LPAD(SUBSTR(NF.NRINSJURNF,15,6),10,'0'),NF.NRINSJURNF), ' '), 16, ' ')       AS CODIGOPFPJ,
                     ROUND(ABS(NVL(IT.VRUNITITEM / NVL(PD.VRFATOCONV,1),0)),2) AS VRUNITARIO,
                     ROUND(ABS(NVL(IT.VRTOTAITEM,0)),2) AS VRTOTAL,
                     ROUND(ABS(NVL((IT.VRCONTITEM/IT.QTITEMPROD/NVL(PD.VRFATOCONV,1)),0)),2) AS CUSTOUNIT,
                     ROUND(ABS(NVL(IT.QTITEMPROD * NVL(PD.VRFATOCONV,1) * (IT.VRCONTITEM/IT.QTITEMPROD/NVL(PD.VRFATOCONV,1)),0)),2) AS CUSTOTOT,
                     USR_CONTPROD(NF.CDTIPOOPER, 'E',IT.CDPRODUTO) AS CONTAESTOQ,
                     RPAD(NVL(IT.NRSEQITPROD, 'NA'), 40, ' ')                 AS NRARQUIV,
                     RPAD(LPAD(NVL(NF.CDFILIRECE, '0'),10,'0'), 28, ' ')         AS CENTROCUSTO,
                     RPAD(NVL(IT.CDFISOPEITEM, ' '), 6, ' ')       AS CFOPITEM,
                     ROUND(NVL(USR_VRTOTIPI(IT.CDFILIAL, IT.NRLANCTONF, IT.NRSEQITPROD),0),2) AS VRIPI,
                     RPAD(NVL(IT.CDSITUTRIBPR, ' '), 3, ' ') AS CSTITEM,
                     RPAD(' ', 12, ' ') AS DSESPACO1
                FROM NOTAFISCAL NF, ITEMPRODUTO IT, PRODUTO PD, FILIAL FI, PRODFILI PF
               WHERE (NF.CDFILIRECE = P_CDFILIAL)
                 AND (FI.CDFILIAL = P_CDFILIAL)
                 AND (NF.DTENTRSAID BETWEEN P_DATAINI AND P_DATAFIN)
                 AND (NF.IDENTRSAIDOP = 'E')
                 AND (NF.CDFILIAL = IT.CDFILIAL)
                 AND (NF.NRLANCTONF = IT.NRLANCTONF)
                 AND (IT.CDPRODUTO = PD.CDPRODUTO)
                 AND (FI.CDFILIAL = PF.CDFILIAL)
                 AND (PD.CDPRODESTO = PF.CDPRODUTO)
                 AND (PF.IDCNTRESTOQ = 'S')
               UNION ALL
              SELECT RPAD(NVL(FI.CDEMPRESAP, ' '), 9, ' ') AS CDEMPRSAP,
                     RPAD(NVL(NF.CDFILIEMIT, ' '), 9, ' ')        AS CDFILIAL,
                     RPAD(NVL(PD.CDNATUPROD, ' '), 5, ' ')        AS NATUREZA,
                     NF.DTENTRSAID AS DTLANCAMENTO,
                     RPAD(NVL(PD.CDARVPROD, ' '), 20, ' ')        AS CDMATERIAL,
                     DECODE(NF.CDTIPOOPER, '01', '15',
                          DECODE(NF.CDTIPOOPER, '02', '16',
                          DECODE(NF.CDTIPOOPER, '03', '17',
                          DECODE(NF.CDTIPOOPER, '04', '18',
                          DECODE(NF.CDTIPOOPER, '05', '19',
                          DECODE(NF.CDTIPOOPER, '06', '20',
                          DECODE(NF.CDTIPOOPER, '07', '21',
                          DECODE(NF.CDTIPOOPER, '08', '22',
                          DECODE(NF.CDTIPOOPER, '09', '23',
                          DECODE(NF.CDTIPOOPER, '10', '24',
                          DECODE(NF.CDTIPOOPER, '11', '25','26' ))))))))))) AS TIPOOPERAC,
                     ROUND(IT.QTLANCTOEST,3) AS QUANTIDADE,
                     'S'                                AS IDLANCAMENTO,
                     DECODE(NF.CDTIPOOPER, '09', 'VTS',
                            DECODE(NF.CDTIPOOPER, '10', 'SNF', 'NFS')) AS TIPODOC,
                     RPAD(NVL(NF.NRNOTAFISC, ' '), 15, ' ')       AS NRDOC,
                     RPAD(NVL(NF.CDSERIE, ' '), 5, ' ')           AS SERIEDOC,
                     RPAD(NVL(IT.NRSEQUITEM, ' '), 15,' ')       AS NRITNF,
                     DECODE(NF.IDORIGDESTNF, 'C', 'CL',
                            DECODE(NF.IDORIGDESTNF, 'F', 'FO', 'CL')) AS CATEGORIAPFPJ,
                     RPAD(NVL(DECODE(NF.IDTPIJURNF, 'I',LPAD(SUBSTR(NF.NRINSJURNF,15,6),10,'0'),NF.NRINSJURNF), ' '), 16, ' ')       AS CODIGOPFPJ,
                     ROUND(ABS(IT.VRUNILANCTO),2) AS VRUNITARIO,
                     ROUND(ABS(IT.VRTOTLANCTO),2) AS VRTOTAL,
                     ROUND(ABS(NVL(CUSTO_PRODUTO_LCEST(CDFILIEMIT, CDPRODMOVI, NVL(CDTIPCUSTEST,3),DTLANCMOVI,SYSDATE,IT.CDALMOXARIFE, IT.CDLOCALESTOQ,
                                                       IT.NRLOTEESTQ, IT.NRSUBLOTE),0)),2) AS CUSTOUNIT,
                     ROUND(ABS(NVL(CUSTO_PRODUTO_LCEST(CDFILIEMIT, CDPRODMOVI,NVL(CDTIPCUSTEST,3),DTLANCMOVI,SYSDATE,IT.CDALMOXARIFE, IT.CDLOCALESTOQ,
                                                       IT.NRLOTEESTQ, IT.NRSUBLOTE) * IT.QTLANCTOEST,0)),2) AS CUSTOTOT,
                     USR_CONTPROD(NF.CDTIPOOPER, 'S',IT.CDPRODUTO) AS CONTAESTOQ,
                     RPAD(NVL(IT.NRSEQUITEM, 'NA'), 40, ' ')                 AS NRARQUIV,
                     RPAD(LPAD(NVL(NF.CDFILIEMIT, '0'),10,'0'), 28, ' ')         AS CENTROCUSTO,
                     RPAD(NVL(USR_CFOPITEM(NF.CDFILIAL, NF.NRLANCTONF, IT.CDPRODUTO), ' '), 6, ' ')       AS CFOPITEM,
                     0 AS VRIPI,
                     RPAD(NVL(USR_CSTITEM(NF.CDFILIAL, NF.NRLANCTONF, IT.CDPRODUTO), ' '), 3, ' ')       AS CSTITEM,
                     RPAD(' ', 12, ' ') AS DSESPACO1
                FROM NOTAFISCAL NF, LANCTOESTOQ LE, ITLANCTOEST IT, PRODUTO PD,
                     FILIAL FI, PARAMFILIAL P
               WHERE (NF.CDFILIEMIT = P_CDFILIAL)
                 AND (FI.CDFILIAL   = P_CDFILIAL)
                 AND (P.CDFILIAL    = P_CDFILIAL)
                 AND (NF.IDENTRSAIDOP = 'S')
                 AND (NF.DTENTRSAID BETWEEN P_DATAINI AND P_DATAFIN)
                 AND (NF.CDFILIEMIT = P.CDFILIAL)
                 AND (NF.CDFILIEMIT = FI.CDFILIAL)
                 AND (NF.CDFILIAL = LE.CDFILIAL)
                 AND (NF.NRLANCTONF = LE.NRLANCTONF)
                 AND (LE.CDFILIAL = IT.CDFILIAL)
                 AND (LE.NRLANCESTQ = IT.NRLANCESTQ)
                 AND (IT.CDPRODUTO = PD.CDPRODUTO)
               UNION ALL
              SELECT RPAD(NVL(FI.CDEMPRESAP, ' '), 9, ' ') AS CDEMPRSAP,
                     RPAD(NVL(R.CDFILIMOVIEST, ' '), 9, ' ')          AS CDFILIAL,
                     RPAD(NVL(PD.CDNATUPROD, ' '), 5, ' ')        AS NATUREZA,
                     R.DTLANCMOVIEST AS DTLANCAMENTO,
                     RPAD(NVL(PD.CDARVPROD, ' '), 20, ' ')        AS CDMATERIAL,
                     DECODE(R.IDTIPOMOVIEST,'0','29','1','28','3','27')        AS TIPOOPERAC,
                     ROUND(ABS(R.QTLANCAMENTO),3) AS QUANTIDADE,
                     DECODE(R.IDTIPOMOVIEST, '3', 'S', DECODE(SUBSTR(LTRIM(TO_CHAR(R.QTLANCAMENTO)),1,1),'-','S','E'))    AS IDLANCAMENTO,
                     DECODE(R.IDTIPOMOVIEST, '0','IME','1','AJI','3','RET')  AS TIPODOC,
                     RPAD(R.NRLANCMOVIEST, 15, ' ')                 AS NRDOC,
                     RPAD(' ', 5, ' ')                  AS SERIEDOC,
                     RPAD(' ', 15,' ')                  AS NRITNF,
                     RPAD(DECODE(R.IDTIPOMOVIEST, '3', 'CL', 'FO'),  2, ' ')                 AS CATEGORIAPFPJ,
                     RPAD(FI.NRINSJURFILI, 16, ' ')                 AS CODIGOPFPJ,
                     ROUND(ABS(NVL(R.VRCUSTMEDI,0)),2) AS VRUNITARIO,
                     ROUND(ABS(NVL(ROUND(R.VRCUSTMEDI,2) * ROUND(R.QTLANCAMENTO,3),0)),2) AS VRTOTAL,
                     ROUND(ABS(NVL(R.VRCUSTMEDI,0)),2) AS CUSTOUNIT,
                     ROUND(ABS(NVL(ROUND(R.QTLANCAMENTO,3) * ROUND(R.VRCUSTMEDI,2),0)),2) AS CUSTOTOT,
                     DECODE(R.IDTIPOMOVIEST, '3',USR_CONTPROD('', 'S',R.CDPRODMOVIEST),USR_CONTPROD('', 'E',R.CDPRODMOVIEST)) AS CONTAESTOQ,
                     RPAD('NA', 40, ' ')                 AS NRARQUIV,
                     RPAD(LPAD(NVL(FI.CDFILIAL, '0'),10,'0'), 28, ' ')         AS CENTROCUSTO,
                     RPAD(' ', 6, ' ')       AS CFOPITEM,
                     0 AS VRIPI,
                     RPAD(' ', 3, ' ')       AS CSTITEM,
                     RPAD(' ', 12, ' ') AS DSESPACO1
                FROM PRODUTO PD, RELAT_MOVIEST R, FILIAL FI
               WHERE (R.NRRELATMOVI = P_NUMEMOVI)
                 AND (R.CDFILIMOVIEST = FI.CDFILIAL)
                 AND (R.IDTIPOMOVIEST IN ('0','1'))
                 AND (R.QTLANCAMENTO <> 0 )
                 AND (R.CDPRODMOVIEST = PD.CDPRODUTO)
               UNION ALL
              SELECT RPAD(NVL(FI.CDEMPRESAP, ' '), 9, ' ') AS CDEMPRSAP,
                     RPAD(NVL(IT.CDFILIMOVI, ' '), 9, ' ')          AS CDFILIAL,
                     RPAD(NVL(PD.CDNATUPROD, ' '), 5, ' ')        AS NATUREZA,
                     DTLANCMOVI AS DTLANCAMENTO,
                     RPAD(NVL(PD.CDARVPROD, ' '), 20, ' ')        AS CDMATERIAL,
                     '27'         AS TIPOOPERAC,
                     ROUND(ABS(IT.QTLANCTOEST),3) AS QUANTIDADE,
                     'S'     AS IDLANCAMENTO,
                     'RET'   AS TIPODOC,
                     RPAD(IT.NRLANCESTQ, 15, ' ')                 AS NRDOC,
                     RPAD(' ', 5, ' ')                  AS SERIEDOC,
                     RPAD(' ', 15,' ')                  AS NRITNF,
                     RPAD('CL', 2, ' ')                 AS CATEGORIAPFPJ,
                     RPAD(FI.NRINSJURFILI, 16, ' ')                 AS CODIGOPFPJ,
                     ROUND(ABS(NVL(CUSTO_PRODUTO_LCEST(CDFILIMOVI, CDPRODMOVI, NVL(CDTIPCUSTEST,3),DTLANCMOVI,SYSDATE,IT.CDALMOXARIFE, IT.CDLOCALESTOQ,
                                                       IT.NRLOTEESTQ, IT.NRSUBLOTE),0)),2) AS VRUNITARIO,
                     ROUND(ABS(NVL(ROUND(CUSTO_PRODUTO_LCEST(CDFILIMOVI, CDPRODMOVI, NVL(CDTIPCUSTEST,3),DTLANCMOVI,SYSDATE,IT.CDALMOXARIFE, IT.CDLOCALESTOQ,
                                                             IT.NRLOTEESTQ, IT.NRSUBLOTE),2) * ROUND(IT.QTLANCTOEST,3),0)),2) AS VRTOTAL,
                     ROUND(ABS(NVL(CUSTO_PRODUTO_LCEST(CDFILIMOVI, CDPRODMOVI, NVL(CDTIPCUSTEST,3),DTLANCMOVI,SYSDATE,IT.CDALMOXARIFE, IT.CDLOCALESTOQ,
                                                       IT.NRLOTEESTQ, IT.NRSUBLOTE),0)), 2) AS CUSTOUNIT,
                     ROUND(ABS(NVL(ROUND(IT.QTLANCTOEST,3) * ROUND(CUSTO_PRODUTO_LCEST(CDFILIMOVI, CDPRODMOVI, NVL(CDTIPCUSTEST,3),DTLANCMOVI,SYSDATE,IT.CDALMOXARIFE, IT.CDLOCALESTOQ,
                                                                   IT.NRLOTEESTQ, IT.NRSUBLOTE),2),0)),2) AS CUSTOTOT,
                     USR_CONTPROD('', 'S',IT.CDPRODMOVI)  AS CONTAESTOQ,
                     RPAD('NA', 40, ' ')                 AS NRARQUIV,
                     RPAD(LPAD(NVL(FI.CDFILIAL, '0'),10,'0'), 28, ' ')         AS CENTROCUSTO,
                     RPAD(' ', 6, ' ')       AS CFOPITEM,
                     0 AS VRIPI,
                     RPAD(' ', 3, ' ')       AS CSTITEM,
                     RPAD(' ', 12, ' ') AS DSESPACO1
                FROM PARAMFILIAL P, PRODUTO PD, ITLANCTOEST IT, FILIAL FI
               WHERE (IT.CDFILIMOVI = P_CDFILIAL)
                 AND (FI.CDFILIAL = P_CDFILIAL)
                 AND (P.CDFILIAL = P_CDFILIAL)
                 AND (IT.DTLANCMOVI BETWEEN P_DTINIRET AND P_DTFINRET)
                 AND (IT.CDFILIMOVI = FI.CDFILIAL)
                 AND (IT.CDFILIMOVI = P.CDFILIAL)
                 AND (IT.IDTIPOMOVI = '3')
                 AND (IT.QTLANCTOEST <> 0)
                 AND (IT.CDPRODMOVI = PD.CDPRODUTO)
               UNION ALL
              SELECT RPAD(NVL(FI.CDEMPRESAP, ' '), 9, ' ')  AS CDEMPRSAP,
                     RPAD(NVL(NF.CDFILIEMIT, ' '), 9, ' ')  AS CDFILIAL,
                     RPAD(NVL(PD.CDNATUPROD, ' '), 5, ' ')  AS NATUREZA,
                     NF.DTENTRSAID AS DTLANCAMENTO,
                     RPAD(NVL(PD.CDARVPROD, ' '), 20, ' ')  AS CDMATERIAL,
                     '15' AS TIPOOPERAC,
                     ROUND(IT.QTITEMPROD,3) AS QUANTIDADE,
                     'S' AS IDLANCAMENTO,
                     'NFS' AS TIPODOC,
                     RPAD(NVL(NF.NRNOTAFISC, ' '), 15, ' ') AS NRDOC,
                     RPAD(NVL(NF.CDSERIE, ' '), 5, ' ')     AS SERIEDOC,
                     RPAD(NVL(IT.NRSEQITPROD, ' '), 15,' ') AS NRITNF,
                     'CL' AS CATEGORIAPFPJ,
                     RPAD(NVL(DECODE(NF.IDTPIJURNF, 'I',LPAD(SUBSTR(NF.NRINSJURNF,15,6),10,'0'),NF.NRINSJURNF), ' '), 16, ' ') AS CODIGOPFPJ,
                     ROUND(ABS(IT.VRUNITITEM),2) AS VRUNITARIO,
                     ROUND(ABS(IT.VRTOTAITEM),2) AS VRTOTAL,
                     ROUND(ABS(IT.VRUNITITEM),2) AS CUSTOUNIT,
                     ROUND(ABS(IT.VRTOTAITEM),2) AS CUSTOTOT,
                     USR_CONTPROD(NF.CDTIPOOPER, 'S',IT.CDPRODUTO) AS CONTAESTOQ,
                     RPAD(NVL(IT.NRSEQITPROD, 'NA'), 40, ' ')      AS NRARQUIV,
                     RPAD(LPAD(NVL(NF.CDFILIEMIT, '0'),10,'0'), 28, ' ') AS CENTROCUSTO,
                     RPAD(NVL(USR_CFOPITEM(NF.CDFILIAL, NF.NRLANCTONF, IT.CDPRODUTO), ' '), 6, ' ') AS CFOPITEM,
                     0 AS VRIPI,
                     RPAD(NVL(USR_CSTITEM(NF.CDFILIAL, NF.NRLANCTONF, IT.CDPRODUTO), ' '), 3, ' ')  AS CSTITEM,
                     RPAD(USR_FLAGD1(NF.CDFILIEMIT, NF.DTENTRSAID, NF.VRNOTAFISC), 12, ' ') AS DSESPACO1
                FROM NOTAFISCAL NF, ITEMPRODUTO IT,
                     PRODUTO PD, FILIAL FI, PARAMFILIAL P
               WHERE NF.CDFILIEMIT = P_CDFILIAL
                 AND NF.IDENTRSAIDOP = 'S'
                 AND NF.CDTIPOOPER = '01'
                 AND NF.CDSERIE = 'ECF'
                 AND NF.DTENTRSAID BETWEEN P_DATAINI AND P_DATAFIN
                 AND IT.CDFILIAL = NF.CDFILIAL
                 AND IT.NRLANCTONF = NF.NRLANCTONF
                 AND IT.CDPRODUTO = PD.CDPRODUTO
                 AND FI.CDFILIAL   = P_CDFILIAL
                 AND P.CDFILIAL    = P_CDFILIAL
                 AND NF.CDFILIEMIT = P.CDFILIAL
                 AND NF.CDFILIEMIT = FI.CDFILIAL
                 AND NOT EXISTS (SELECT PF.CDFILIAL
                                   FROM PRODFILI PF
                                  WHERE PF.CDFILIAL = NF.CDFILIEMIT
                                    AND PF.CDPRODUTO = PD.CDPRODESTO
                                    AND NVL(PF.IDCNTRESTOQ, 'S') = 'S'))
       ORDER BY CDEMPRSAP, CDFILIAL, TIPODOC, DTLANCAMENTO, TIPOOPERAC, NRDOC, SERIEDOC,
                NRITNF, CDMATERIAL, QUANTIDADE;
   /* Registro de Inventrio */
   CURSOR C_ARQ_ESTI IS
      SELECT CDEMPRSAP,
             CDFILIAL,
             RPAD('MP',5,' ') AS CDMP,
             CENTROCUSTO AS CDCENTCUST,
             DTINVENTARIO,
             CDMATERIAL,
             RPAD('001', 10, ' ') AS VRFIXO1,
             RPAD('001',  3, ' ') AS VRFIXO2,
             RPAD(LPAD(NVL(CONTAESTOQUE, '0'),10,'0'), 28, ' ') AS CDCONTAESTOQ,
             QUANTIDADE AS QTPRODUTO,
             UNIDMEDIDA AS SGUNIDPROD,
             CUSTOUNIT  AS VRCUSTOUNIT,
             CUSTOTOT AS VRCUSTOTOTA,
             RPAD(' ', 4, ' ') AS DSESPACO1,
             RPAD(' ', 150, ' ') AS DSESPACO2,
             RPAD('TEC_WIN', 150, ' ') AS DSTEC_WIN,
             RPAD(TO_CHAR(P_DATAPROC, 'ddmmyyyy'), 150, ' ') AS DTPROC,
             RPAD(' ', 150, ' ') AS DSESPACO3,
             RPAD(' ', 150, ' ') AS DSESPACO4,
             RPAD(' ', 150, ' ') AS DSESPACO5,
             LTRIM(RPAD('0', 17, '0')) AS DSSEQZERO1,
             LTRIM(RPAD('0', 17, '0')) AS DSSEQZERO2,
             LTRIM(RPAD('0', 17, '0')) AS DSSEQZERO3
        FROM (SELECT RPAD(NVL(FI.CDEMPRESAP, ' '), 9, ' ') AS CDEMPRSAP,
                     RPAD(NVL(FI.CDFILIAL, ' '), 9, ' ') AS CDFILIAL,
                     RPAD(NVL(PD.CDNATUPROD, ' '), 5, ' ') AS NATUREZA,
                     RPAD(LPAD(NVL(FI.CDFILIAL, ' '),10,'0'), 28, ' ')   AS CENTROCUSTO,
                     P_DATAFIN AS DTINVENTARIO,
                     RPAD(NVL(PD.CDPRODUTO, ' '), 20, ' ') AS CDMATERIAL,
                     USR_CONTPROD('', 'E',PD.CDPRODUTO) AS CONTAESTOQUE,
                     ROUND(ABS(CUST.QTESTOQDIA),3) AS QUANTIDADE,
                     RPAD(NVL(PD.SGUNIDADE, ' '), 3, ' ') AS UNIDMEDIDA,
                     ROUND(ABS(CUST.CUSTPROD),2) AS CUSTOUNIT,
                     ROUND(ABS(CUST.VRESTOQDIA),2) AS CUSTOTOT
                FROM FILIAL FI, PRODUTO PD,
                     (SELECT P.CDFILIAL, A.CDARVPROD AS CDPRODUTO, SUM(P.QTESTOQDIA) AS QTESTOQDIA,
                             SUM(P.VRESTOQDIA) AS VRESTOQDIA,
                             SUM(DECODE(P.QTESTOQDIA, 0.00,
                                 DECODE(P.QTESTOQANT , 0.00, 0.00,
                                 P.VRESTOQANT/P.QTESTOQANT),P.VRESTOQDIA/P.QTESTOQDIA)) AS CUSTPROD
                        FROM POSESTDIA P, PRODUTO A
                       WHERE (P.CDFILIAL = P_CDFILIAL)
                         AND (P.CDPRODUTO = A.CDPRODUTO)
                         AND (A.CDPRODUTO = A.CDPRODESTO)
                         AND (P.VRESTOQDIA > 0)
                         AND (P.CDALMOXARIFE = ' ')
                         AND (P.CDLOCALESTOQ = ' ')
                         AND (P.NRLOTEESTQ = ' ')
                         AND (P.NRSUBLOTE = ' ')
                         AND (P.DTPOSIESTQ = (SELECT Max(DTPOSIESTQ)
                                                FROM POSESTDIA C
                                               WHERE (C.CDFILIAL = P.CDFILIAL)
                                                 AND (C.CDPRODUTO = P.CDPRODUTO)
                                                 AND (C.CDALMOXARIFE = ' ')
                                                 AND (C.CDLOCALESTOQ = ' ')
                                                 AND (C.NRLOTEESTQ = ' ')
                                                 AND (C.NRSUBLOTE = ' ')
                                                 AND (C.DTPOSIESTQ <= (P_DATAPOS+1))))
                       GROUP BY P.CDFILIAL, A.CDARVPROD) CUST
               WHERE (FI.CDFILIAL = P_CDFILIAL)
                 AND (FI.CDFILIAL = CUST.CDFILIAL)
                 AND (PD.CDPRODUTO = CUST.CDPRODUTO));
/* Cadastro de Materiais */
   CURSOR C_ARQ_MAT IS
      SELECT CDEMPRSAP,
             CDFILIAL,
             CDMATERIAL,
             TO_DATE('01'||RPAD(TO_CHAR(P_DATAINI, 'mmyyyy'),6, ' ')) AS DTMOVIMENT,
             DSMATERIAL,
             CLASSEMATERIAL AS IDCLASMATERIAL,
             RPAD('001', 10, ' ') AS VRFIXO1,
             UNIDMEDIDA AS SGUNIDPROD,
             'N' AS VRFIXO2,
             'F' AS VRFIXO3,
             'F' AS VRFIXO4,
             RPAD(' ', 2, ' ') AS DSESPACO1,
             RPAD(' ', 1, ' ') AS DSESPACO2,
             RPAD(' ',10, ' ') AS DSESPACO3,
             RPAD(' ',10, ' ') AS DSESPACO4,
             RPAD(' ',10, ' ') AS DSESPACO5,
             RPAD(' ',30, ' ') AS DSESPACO6,
             RPAD(' ',15, ' ') AS DSESPACO7,
             RPAD(' ',15, ' ') AS DSESPACO8,
             RPAD(' ',15, ' ') AS DSESPACO9,
             RPAD(' ',15, ' ') AS DSESPACO10,
             RPAD(' ',15, ' ') AS DSESPACO11,
             RPAD('TEC_WIN',150, ' ') AS DSTEC_WIN,
             RPAD(TO_CHAR(P_DATAPROC, 'ddmmyyyy'),150, ' ') AS DTPROC,
             RPAD(' ',150, ' ') AS DSESPACO12,
             RPAD(' ',150, ' ') AS DSESPACO13,
             RPAD(' ',150, ' ') AS DSESPACO14,
             LTRIM(RPAD('0', 17, '0')) AS DSSEQZERO1,
             LTRIM(RPAD('0', 17, '0')) AS DSSEQZERO2,
             LTRIM(RPAD('0', 17, '0')) AS DSSEQZERO3,
             RPAD(CDCLASFISC,10, ' ') AS CDCLASFISC
        FROM (SELECT RPAD(NVL(FI.CDEMPRESAP, ' '), 9, ' ') AS CDEMPRSAP,
                     RPAD(NVL(FI.CDFILIAL, ' ')  , 9, ' ') AS CDFILIAL,
                     RPAD(NVL(PD.CDARVPROD, ' '), 20, ' ') AS CDMATERIAL,
                     RPAD(NVL(PD.NMPRODUTO, ' '),150, ' ') AS DSMATERIAL,
                     RPAD('I', 1, ' ') AS CLASSEMATERIAL,
                     RPAD(NVL(PD.SGUNIDADE, ' '),  3, ' ') AS UNIDMEDIDA,
                     DTULTATUPROD,
                     PD.CDCLASFISC
                FROM FILIAL FI, PRODUTO PD
               WHERE (FI.CDFILIAL = P_CDFILIAL)
                 AND (PD.CDNVPRODUTO = P_TOTNIVEL)
                 AND (TRUNC(PD.DTULTATUPROD) BETWEEN ADD_MONTHS(TO_DATE(P_DATAINI),-1) AND TO_DATE(P_DATAINI)));
/* Exporta todo cadastro de Materiais */
   CURSOR C_ARQ_TMAT IS
      SELECT CDEMPRSAP,
             CDFILIAL,
             CDMATERIAL,
             ('01'||RPAD(TO_CHAR(P_DATAINI, 'mmyyyy'),6, ' ')) AS DTMOVIMENT,
             DSMATERIAL,
             CLASSEMATERIAL AS IDCLASMATERIAL,
             RPAD('001', 10, ' ') AS VRFIXO1,
             UNIDMEDIDA AS SGUNIDPROD,
             'N' AS VRFIXO2,
             'F' AS VRFIXO3,
             'F' AS VRFIXO4,
             RPAD(' ', 2, ' ') AS DSESPACO1,
             RPAD(' ', 1, ' ') AS DSESPACO2,
             RPAD(' ',10, ' ') AS DSESPACO3,
             RPAD(' ',10, ' ') AS DSESPACO4,
             RPAD(' ',10, ' ') AS DSESPACO5,
             RPAD(' ',30, ' ') AS DSESPACO6,
             RPAD(' ',15, ' ') AS DSESPACO7,
             RPAD(' ',15, ' ') AS DSESPACO8,
             RPAD(' ',15, ' ') AS DSESPACO9,
             RPAD(' ',15, ' ') AS DSESPACO10,
             RPAD(' ',15, ' ') AS DSESPACO11,
             RPAD('TEC_WIN',150, ' ') AS DSTEC_WIN,
             RPAD(TO_CHAR(P_DATAPROC, 'ddmmyyyy'),150, ' ') AS DTPROC,
             RPAD(' ',150, ' ') AS DSESPACO12,
             RPAD(' ',150, ' ') AS DSESPACO13,
             RPAD(' ',150, ' ') AS DSESPACO14,
             LTRIM(RPAD('0', 17, '0')) AS DSSEQZERO1,
             LTRIM(RPAD('0', 17, '0')) AS DSSEQZERO2,
             LTRIM(RPAD('0', 17, '0')) AS DSSEQZERO3,
             RPAD(CDCLASFISC,10, ' ') AS CDCLASFISC
        FROM (SELECT RPAD(NVL(FI.CDEMPRESAP, ' '), 9, ' ') AS CDEMPRSAP,
                     RPAD(NVL(FI.CDFILIAL, ' ')  , 9, ' ') AS CDFILIAL,
                     RPAD(NVL(PD.CDARVPROD, ' '), 20, ' ') AS CDMATERIAL,
                     RPAD(NVL(PD.NMPRODUTO, ' '),150, ' ') AS DSMATERIAL,
                     RPAD('I', 1, ' ') AS CLASSEMATERIAL,
                     RPAD(NVL(PD.SGUNIDADE, ' '),  3, ' ') AS UNIDMEDIDA,
                     DTULTATUPROD,
                     PD.CDCLASFISC
                FROM FILIAL FI, PRODUTO PD
               WHERE (FI.CDFILIAL = P_CDFILIAL)
                 AND (PD.CDNVPRODUTO = P_TOTNIVEL)
                 AND ((P_EXPCADMAT   = 'S') OR
                     ((P_EXPCADMAT   = 'N')
                 AND (PD.DTULTATUPROD BETWEEN P_DATAINI AND P_DATAFIN))));
BEGIN
   V_TRUNCTAB := 'N';
   /* Dados Mestres de ECF - Sadas */
   IF P_ARQUIVO = 'SDX00310' THEN
      FOR C_DADOS IN C_ARQ_ECFM LOOP
         IF V_TRUNCTAB = 'N' THEN
            DELETE FROM IN86_ARQ_ECFM
             WHERE CDFILIAL = C_DADOS.CDFILIAL
               AND DTREDUCAOZ BETWEEN P_DATAINI AND P_DATAFIN;
            V_TRUNCTAB := 'S';
         END IF;
         INSERT INTO IN86_ARQ_ECFM
            (CDEMPRSAP, CDFILIAL, NRECFREDZ, DTREDUCAOZ, CDMAPRESUMO, NRPRIMCFREDZ,
             NRULTCFREDZ, VRREDZ, VRGRTOTAL, NRREDREDZ, NRREINIREDZ, DSTEC_WIN,
             DTPROC, DSESPACO1, DSESPACO2, DSESPACO3, DSSEQZERO1, DSSEQZERO2, DSSEQZERO3,
             NRSERIEREDZ, NRSERIEIMPR, NRECFIMPR, DSMODEIMPR, NRCUPOMFISC, VLR_GT_INI,
             VLR_VENDA_LIQ)
         VALUES
            (C_DADOS.CDEMPRSAP, C_DADOS.CDFILIAL, C_DADOS.NRECFREDZ, C_DADOS.DTREDUCAOZ, C_DADOS.CDMAPRESUMO, C_DADOS.NRPRIMCFREDZ,
             C_DADOS.NRULTCFREDZ, C_DADOS.VRREDZ, C_DADOS.VRGRTOTAL, C_DADOS.NRREDREDZ, C_DADOS.NRREINIREDZ, C_DADOS.DSTEC_WIN,
             C_DADOS.DTPROC, C_DADOS.DSESPACO1, C_DADOS.DSESPACO2, C_DADOS.DSESPACO3, C_DADOS.DSSEQZERO1, C_DADOS.DSSEQZERO2, C_DADOS.DSSEQZERO3,
             C_DADOS.NRSERIEREDZ, C_DADOS.NRSERIEIMPR, C_DADOS.NRECFIMPR, C_DADOS.DSMODEIMPR, C_DADOS.NRCUPOMFISC, C_DADOS.VLR_GT_INI,
             C_DADOS.VLR_VENDA_LIQ);
      END LOOP;
   ELSIF P_ARQUIVO = 'SDX00311' THEN
      FOR C_DADOS IN C_ARQ_ECFI LOOP
         IF V_TRUNCTAB = 'N' THEN
            DELETE FROM IN86_ARQ_ECFI
             WHERE CDFILIAL = C_DADOS.CDFILIAL
               AND DTREDUCAOZ BETWEEN P_DATAINI AND P_DATAFIN;
            V_TRUNCTAB := 'S';
         END IF;
         INSERT INTO IN86_ARQ_ECFI
            (CDEMPRSAP, CDFILIAL, NRECFREDZ, DTREDUCAOZ, VRSITUTRIB,
             DSSITUTRIB, VRACUMULADO, VRBASECALC, VRCONTABIL, DSTEC_WIN,
             DTPROC, DSESPACO1, DSESPACO2, DSESPACO3, DSSEQZERO1,
             DSSEQZERO2, DSSEQZERO3, NRCUPOMFISC)
         VALUES
            (C_DADOS.CDEMPRSAP, C_DADOS.CDFILIAL, C_DADOS.NRECFREDZ, C_DADOS.DTREDUCAOZ, C_DADOS.VRSITUTRIB,
             C_DADOS.DSSITUTRIB, C_DADOS.VRACUMULADO, C_DADOS.VRBASECALC, C_DADOS.VRCONTABIL, C_DADOS.DSTEC_WIN,
             C_DADOS.DTPROC, C_DADOS.DSESPACO1, C_DADOS.DSESPACO2, C_DADOS.DSESPACO3, C_DADOS.DSSEQZERO1,
             C_DADOS.DSSEQZERO2, C_DADOS.DSSEQZERO3, C_DADOS.NRCUPOMFISC);
      END LOOP;
   ELSIF P_ARQUIVO = 'SDX00312' THEN
      FOR C_DADOS IN C_ARQ_ECFR LOOP
         IF V_TRUNCTAB = 'N' THEN
            DELETE FROM IN86_ARQ_ECFR
             WHERE CDFILIAL = C_DADOS.CDFILIAL
               AND DTENTRVENDA BETWEEN P_DATAINI AND P_DATAFIN;
            V_TRUNCTAB := 'S';
         END IF;

         /* Verifica CFOP do produto pertencente a venda */
         BEGIN
            SELECT SUBSTR(MAX(CDFISCOPER),1,3)
              INTO V_CDFISCOPER
              FROM CODFISCOPER C, PRODUTO P,
                   (SELECT CDEMPRESA, CDINSCESTA
                      FROM FILIAL
                     WHERE CDFILIAL = C_DADOS.CDFILIVENDA) F
             WHERE C.IDENTSAICFOP = 'S'
               AND C.CDEMPRESA    = F.CDEMPRESA
               AND C.CDTIPOOPER   = '01'
               AND C.CDINSCESTA   = F.CDINSCESTA
               AND C.CDGRUPOFISC IS NULL
               AND IDCFOPINTEREST = 'N'
               AND C.CDPRODUTO    = P.CDPRODUTO(+)
               AND (INSTR(C_DADOS.CDARVPROD,NVL(RTRIM(P.CDARVPROD),C_DADOS.CDARVPROD)) = 1)
               AND C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                       FROM CODFISCOPER C, PRODUTO P
                                      WHERE C.IDENTSAICFOP = 'S'
                                        AND C.CDEMPRESA    = F.CDEMPRESA
                                        AND C.CDTIPOOPER   = '01'
                                        AND C.CDINSCESTA   = F.CDINSCESTA
                                        AND C.CDGRUPOFISC IS NULL
                                        AND IDCFOPINTEREST = 'N'
                                        AND C.CDPRODUTO    = P.CDPRODUTO(+)
                                        AND (INSTR(C_DADOS.CDARVPROD,NVL(RTRIM(P.CDARVPROD),C_DADOS.CDARVPROD)) = 1)
                                        AND C.DTVALIDCFOP <= C_DADOS.DTENTRVENDA);
         EXCEPTION
            When No_Data_Found Then
               V_CDFISCOPER := NULL;
         END;

         IF NOT V_CDFISCOPER IS NULL THEN
            V_CDFISCOPER := '5' || V_CDFISCOPER;
         END IF;

         /* Verifica CST do produto pertencente a venda */
         BEGIN
            SELECT CDCSTDIG1PROD
              INTO V_CST1DIGT
              FROM PRODUTO
             WHERE CDARVPROD = C_DADOS.CDARVPROD;

            IF V_CST1DIGT IS NULL THEN
               SELECT CDCSTDIG1SAI
                 INTO V_CST1DIGT
                 FROM INSCRESTAD I,
                      (SELECT CDEMPRESA, CDINSCESTA
                         FROM FILIAL
                        WHERE CDFILIAL = C_DADOS.CDFILIVENDA) F
                WHERE I.CDEMPRESA  = F.CDEMPRESA
                  AND I.CDINSCESTA = F.CDINSCESTA;
            END IF;
         EXCEPTION
            When No_Data_Found Then
               V_CST1DIGT := Null;
         END;

         BEGIN
            SELECT SUBSTR(MAX(CDSITUTRIB),1,2)
              INTO V_CDCSTPROD
              FROM CODSITUTRIB C, PRODUTO P,
                   (SELECT CDEMPRESA, CDINSCESTA
                      FROM FILIAL
                     WHERE CDFILIAL = C_DADOS.CDFILIVENDA) F
             WHERE C.IDENTSAICST  = 'S'
               AND C.CDEMPRESA    = F.CDEMPRESA
               AND C.CDTIPOOPER   = '01'
               AND C.CDINSCESTA   = F.CDINSCESTA
               AND C.CDGRUPOFISC IS NULL
               AND C.IDCSTINTEREST = 'N'
               AND C.IDCSTINTERNA  = 'N'
               AND C.CDPRODUTO    = P.CDPRODUTO(+)
               AND (INSTR(C_DADOS.CDARVPROD,NVL(RTRIM(P.CDARVPROD),C_DADOS.CDARVPROD)) = 1);
         EXCEPTION
            When No_Data_Found Then
               V_CDCSTPROD := NULL;
         END;

         INSERT INTO IN86_ARQ_ECFR
            (CDEMPRSAP, CDFILIAL, DTENTRVENDA, NMCAIXA, NRECFREDZ,
             NRCUPOMFISC, NRSEQUITVEND, IDTPIMPOSFIS, VRFIXO1,
             VRFIXO2, CDMATERIAL, QTPRODVEND, VRUNITARIO, VRBASECALC,
             VRIMPOSTO, DSTEC_WIN, DTPROC, DSESPACO1, DSESPACO2,
             DSESPACO3, DSSEQZERO1, DSSEQZERO2, DSSEQZERO3,
             NMCLIENTE, NRCPFCLIE, VRCUPOCANC, VRITEMCANC, IDITEMCANC,
             COD_CFO, CST_ICMS)
         VALUES
            (C_DADOS.CDEMPRSAP, C_DADOS.CDFILIAL, C_DADOS.DTENTRVENDA, C_DADOS.NMCAIXA, C_DADOS.NRECFREDZ,
             C_DADOS.NRCUPOMFISC, C_DADOS.NRSEQUITVEND, C_DADOS.IDTPIMPOSFIS, C_DADOS.VRFIXO1,
             C_DADOS.VRFIXO2, C_DADOS.CDMATERIAL, C_DADOS.QTPRODVEND, C_DADOS.VRUNITARIO, C_DADOS.VRBASECALC,
             C_DADOS.VRIMPOSTO, C_DADOS.DSTEC_WIN, C_DADOS.DTPROC, C_DADOS.DSESPACO1, C_DADOS.DSESPACO2,
             C_DADOS.DSESPACO3, C_DADOS.DSSEQZERO1, C_DADOS.DSSEQZERO2, C_DADOS.DSSEQZERO3,
             C_DADOS.NMCLIENTE, C_DADOS.NRCPFCLIE, C_DADOS.VRCUPOCANC, C_DADOS.VRITEMCANC, C_DADOS.IDITEMCANC,
             V_CDFISCOPER, V_CST1DIGT || V_CDCSTPROD);
      END LOOP;
   ELSIF P_ARQUIVO = 'SDX00313' THEN
      FOR C_DADOS IN C_ARQ_ESTL LOOP
         IF V_TRUNCTAB = 'N' THEN
            DELETE FROM IN86_ARQ_ESTL
             WHERE CDFILIAL = C_DADOS.CDFILIAL
               AND DTLANCAMENTO BETWEEN P_DATAINI AND P_DATAFIN;
            V_TRUNCTAB := 'S';
         END IF;
         INSERT INTO IN86_ARQ_ESTL
            (CDEMPRSAP, CDFILIAL, CDMP, DTLANCAMENTO, CDMATERIAL, CDTIPOOPER,
             QTPRODUTO, IDLANCAMENTO, NRSEQITPROD, CDTIPODOCU, NRNOTAFISC, CDSERIE,
             NRITNF, DSESPACO1, CDCATEGORIAPFPJ, CDPFPJ, VRFIXO1, VRUNITPROD,
             VRTOTAITEM, VRCUSTOUNIT, VRCUSTOTOT, CDCONTAESTOQ, DSESPACO2,
             DSESPACO3, CDCENTCUST, CDCFOPPROD, VRIPIPROD, VRFIXO2, DSESPACO4,
             DSESPACO5, DSESPACO6, DSESPACO7, DSESPACO8, DSESPACO9, DSTEC_WIN,
             DTPROC, DSESPACO10, DSESPACO11, DSESPACO12, DSSEQZERO1,
             DSSEQZERO2, DSSEQZERO3, CST_ICMS)
         VALUES
            (C_DADOS.CDEMPRSAP, C_DADOS.CDFILIAL, C_DADOS.CDMP, C_DADOS.DTLANCAMENTO, C_DADOS.CDMATERIAL, C_DADOS.CDTIPOOPER,
             C_DADOS.QTPRODUTO, C_DADOS.IDLANCAMENTO, C_DADOS.NRSEQITPROD, C_DADOS.CDTIPODOCU, C_DADOS.NRNOTAFISC, C_DADOS.CDSERIE,
             C_DADOS.NRITNF, C_DADOS.DSESPACO1, C_DADOS.CDCATEGORIAPFPJ, C_DADOS.CDPFPJ, C_DADOS.VRFIXO1, C_DADOS.VRUNITPROD,
             C_DADOS.VRTOTAITEM, C_DADOS.VRCUSTOUNIT, C_DADOS.VRCUSTOTOT, C_DADOS.CDCONTAESTOQ, C_DADOS.DSESPACO2,
             C_DADOS.DSESPACO3, C_DADOS.CDCENTCUST, C_DADOS.CDCFOPPROD, C_DADOS.VRIPIPROD, C_DADOS.VRFIXO2, C_DADOS.DSESPACO4,
             C_DADOS.DSESPACO5, C_DADOS.DSESPACO6, C_DADOS.DSESPACO7, C_DADOS.DSESPACO8, C_DADOS.DSESPACO9, C_DADOS.DSTEC_WIN,
             C_DADOS.DTPROC, C_DADOS.DSESPACO10, C_DADOS.DSESPACO11, C_DADOS.DSESPACO12, C_DADOS.DSSEQZERO1,
             C_DADOS.DSSEQZERO2, C_DADOS.DSSEQZERO3, C_DADOS.CSTITEM);
      END LOOP;
   ELSIF P_ARQUIVO = 'SDX00314' THEN
      FOR C_DADOS IN C_ARQ_ESTI LOOP
         IF V_TRUNCTAB = 'N' THEN
            DELETE FROM IN86_ARQ_ESTI
             WHERE CDFILIAL = C_DADOS.CDFILIAL;
            V_TRUNCTAB := 'S';
         END IF;
         INSERT INTO IN86_ARQ_ESTI
            (CDEMPRSAP, CDFILIAL, CDMP, CDCENTCUST, DTINVENTARIO,
             CDMATERIAL, VRFIXO1, VRFIXO2, CDCONTAESTOQ, QTPRODUTO,
             SGUNIDPROD, VRCUSTOUNIT, VRCUSTOTOTA, DSESPACO1, DSESPACO2,
             DSTEC_WIN, DTPROC, DSESPACO3, DSESPACO4, DSESPACO5,
             DSSEQZERO1, DSSEQZERO2, DSSEQZERO3)
         VALUES
            (C_DADOS.CDEMPRSAP, C_DADOS.CDFILIAL, C_DADOS.CDMP, C_DADOS.CDCENTCUST, C_DADOS.DTINVENTARIO,
             C_DADOS.CDMATERIAL, C_DADOS.VRFIXO1, C_DADOS.VRFIXO2, C_DADOS.CDCONTAESTOQ, C_DADOS.QTPRODUTO,
             C_DADOS.SGUNIDPROD, C_DADOS.VRCUSTOUNIT, C_DADOS.VRCUSTOTOTA, C_DADOS.DSESPACO1, C_DADOS.DSESPACO2,
             C_DADOS.DSTEC_WIN, C_DADOS.DTPROC, C_DADOS.DSESPACO3, C_DADOS.DSESPACO4, C_DADOS.DSESPACO5,
             C_DADOS.DSSEQZERO1, C_DADOS.DSSEQZERO2, C_DADOS.DSSEQZERO3);
      END LOOP;
   ELSIF P_ARQUIVO = 'SDX00315' THEN
      IF P_EXPMANUAL = 'S' THEN
         FOR C_DADOS IN C_ARQ_TMAT LOOP
            IF V_TRUNCTAB = 'N' THEN
               DELETE FROM IN86_ARQ_MAT
                WHERE CDFILIAL = C_DADOS.CDFILIAL;
               V_TRUNCTAB := 'S';
            END IF;
            INSERT INTO IN86_ARQ_MAT
               (CDEMPRSAP, CDFILIAL, CDMATERIAL, DTMOVIMENT, DSMATERIAL, IDCLASMATERIAL,
                VRFIXO1, SGUNIDPROD, VRFIXO2, VRFIXO3, VRFIXO4, DSESPACO1, DSESPACO2,
                DSESPACO3, DSESPACO4, DSESPACO5, DSESPACO6, DSESPACO7, DSESPACO8, DSESPACO9,
                DSESPACO10, DSESPACO11, DSTEC_WIN, DTPROC, DSESPACO12, DSESPACO13,
                DSESPACO14, DSSEQZERO1, DSSEQZERO2, DSSEQZERO3,
                COD_NCM)
            VALUES
               (C_DADOS.CDEMPRSAP, C_DADOS.CDFILIAL, C_DADOS.CDMATERIAL, C_DADOS.DTMOVIMENT, C_DADOS.DSMATERIAL, C_DADOS.IDCLASMATERIAL,
                C_DADOS.VRFIXO1, C_DADOS.SGUNIDPROD, C_DADOS.VRFIXO2, C_DADOS.VRFIXO3, C_DADOS.VRFIXO4, C_DADOS.DSESPACO1, C_DADOS.DSESPACO2,
                C_DADOS.DSESPACO3, C_DADOS.DSESPACO4, C_DADOS.DSESPACO5, C_DADOS.DSESPACO6, C_DADOS.DSESPACO7, C_DADOS.DSESPACO8, C_DADOS.DSESPACO9,
                C_DADOS.DSESPACO10, C_DADOS.DSESPACO11, C_DADOS.DSTEC_WIN, C_DADOS.DTPROC, C_DADOS.DSESPACO12, C_DADOS.DSESPACO13,
                C_DADOS.DSESPACO14, C_DADOS.DSSEQZERO1, C_DADOS.DSSEQZERO2, C_DADOS.DSSEQZERO3,
                C_DADOS.CDCLASFISC);
         END LOOP;
      ELSE
         FOR C_DADOS IN C_ARQ_MAT LOOP
            IF V_TRUNCTAB = 'N' THEN
               DELETE FROM IN86_ARQ_MAT
                WHERE CDFILIAL = C_DADOS.CDFILIAL;
               V_TRUNCTAB := 'S';
            END IF;
            INSERT INTO IN86_ARQ_MAT
               (CDEMPRSAP, CDFILIAL, CDMATERIAL, DTMOVIMENT, DSMATERIAL, IDCLASMATERIAL,
                VRFIXO1, SGUNIDPROD, VRFIXO2, VRFIXO3, VRFIXO4, DSESPACO1, DSESPACO2,
                DSESPACO3, DSESPACO4, DSESPACO5, DSESPACO6, DSESPACO7, DSESPACO8, DSESPACO9,
                DSESPACO10, DSESPACO11, DSTEC_WIN, DTPROC, DSESPACO12, DSESPACO13,
                DSESPACO14, DSSEQZERO1, DSSEQZERO2, DSSEQZERO3,
                COD_NCM)
            VALUES
               (C_DADOS.CDEMPRSAP, C_DADOS.CDFILIAL, C_DADOS.CDMATERIAL, C_DADOS.DTMOVIMENT, C_DADOS.DSMATERIAL, C_DADOS.IDCLASMATERIAL,
                C_DADOS.VRFIXO1, C_DADOS.SGUNIDPROD, C_DADOS.VRFIXO2, C_DADOS.VRFIXO3, C_DADOS.VRFIXO4, C_DADOS.DSESPACO1, C_DADOS.DSESPACO2,
                C_DADOS.DSESPACO3, C_DADOS.DSESPACO4, C_DADOS.DSESPACO5, C_DADOS.DSESPACO6, C_DADOS.DSESPACO7, C_DADOS.DSESPACO8, C_DADOS.DSESPACO9,
                C_DADOS.DSESPACO10, C_DADOS.DSESPACO11, C_DADOS.DSTEC_WIN, C_DADOS.DTPROC, C_DADOS.DSESPACO12, C_DADOS.DSESPACO13,
                C_DADOS.DSESPACO14, C_DADOS.DSSEQZERO1, C_DADOS.DSSEQZERO2, C_DADOS.DSSEQZERO3,
                C_DADOS.CDCLASFISC);
         END LOOP;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_IN86','5.60.XXX'); END;
/

