/* Motivo de bloqueio "avaria" e "vencimento" gerar uma RETIRADA (baixa de estoque) COM O TIPO A SER DEFINIDO, VAI SER FIXO NO CODIGO */
/* Cancelamento de nota, gerar uma devoluo para o estoque (J vai ter sido baixado no estoque, ento vai voltar pro estoque) */
/* Para os demais tipos ser gerado entrada ou saida normalmente */
/* Shelf Life, gerar inventrio */
create or replace PROCEDURE IMPORTA_MOVI_ESTOQUE_SAGA
AS
   --V_NRCONTADOR    INT;

   V_NRLANCESTQ    VARCHAR2(20);
   V_NRSEQITPROD   VARCHAR2(4);

   V_CDPRODUTO     VARCHAR2(10);
   V_CDPRODESTO    VARCHAR2(10);
   V_QTESTCONV     FLOAT;

   V_CDALMOXARIFE  VARCHAR2(6);
   V_CDLOCALESTOQ  VARCHAR2(6);
   V_NRLOTEESTQ    VARCHAR2(20);
   V_NRSUBLOTE     VARCHAR2(4);

   V_VRESTOQDIA    FLOAT;
   V_VRESTOQBRUT   FLOAT;

   V_DTINICIAL    DATE;
   V_DTFINAL      DATE;
   V_DATAPROC     DATE;
   V_CDFILIMOVI   VARCHAR2(4) := ' ';
   V_RETIESTO     VARCHAR2(20);
   V_IDTPLANCTO   VARCHAR2(1);
   V_IDALTCUSMED  VARCHAR2(1);
   V_IDORDEMCLC   VARCHAR2(1);
   V_IDTIPOMOVI   VARCHAR2(1);
   V_DTGRCTRSESQ  DATE := '30/12/1899';
   V_NOMTIPOPE    VARCHAR2(20) := ' ';
   V_BOPOSESTDIA  BOOLEAN;
   V_BOINSEREITEM BOOLEAN;
   V_BOATUALESTOQ BOOLEAN := FALSE;
   V_QTDEESTO     FLOAT;
   V_VALRESTO     FLOAT;
   V_VALRBRUT     FLOAT;
   V_NMPRODUTO    VARCHAR2(50);
   V_CODMTVBLQ    VARCHAR2(125) := ' ';
   V_CDTIPORETI   VARCHAR2(2);
   V_CDSETOR      VARCHAR2(4);
   V_INSERE       FLOAT;
   V_PRODUTOVALID VARCHAR2(20);
   V_VRFATORSKU   FLOAT;
   V_IDPRODMENSU  VARCHAR2(1);
   V_CUSTTOTENTR  FLOAT;
   V_DTPROCESSA   DATE;
   V_CDTIPCUSTEST VARCHAR2(2);
   V_QTESTOQDIA   FLOAT;
   V_VRUNITITEM   FLOAT;
BEGIN
   --V_NRCONTADOR := 0;
   V_NRLANCESTQ   := 'A';
   V_PRODUTOVALID := ' ';
   FOR C_MOV IN (/* Ajuste de Estoque (Adio - Entrada) */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Adio estoque SAGA - Entrada' AS DSLANCESTQ,
                        E.CODMER,
                        ABS(E.VALQTD) VALQTD,
                        E.VALEMBSKU,
                        'E' AS IDENTRSAID,
                        '2' AS IDTPLANCTO,
                        'S' AS IDALTCUSMED,
                        '2' AS IDORDEMCLC,
                        '2' AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ,
                        P.DTPROCESSA,
                        P.CDTIPCUSTEST
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NOT NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 4
                    AND UPPER(E.CODMTVBLQ) LIKE 'ADI%O'
                    AND E.NOMTIPOPE = 'Entrada'
                    AND E.FLAPRC = '0'
                  
                  UNION ALL
                  
                 /* Ajuste de Estoque (Adio - Sada) */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Adio Estoque SAGA - Sada' AS DSLANCESTQ,
                        E.CODMER,
                        ABS(E.VALQTD) VALQTD,
                        E.VALEMBSKU,
                        'S'  AS IDENTRSAID,
                        '4'  AS IDTPLANCTO,
                        NULL AS IDALTCUSMED,
                        '9'  AS IDORDEMCLC,
                        '4'  AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ,
                        P.DTPROCESSA,
                        P.CDTIPCUSTEST
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NOT NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 4
                    AND UPPER(E.CODMTVBLQ) LIKE 'ADI%O'
                    AND E.NOMTIPOPE = 'Sada'
                    AND E.FLAPRC = '0'

                  UNION ALL

                 /* Bloqueio (Quarentena)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Bloqueio de Estoque SAGA (Quarentena)' AS DSLANCESTQ,
                        E.CODMER,
                        ABS(E.VALQTD) ,
                        E.VALEMBSKU,
                        'S'  AS IDENTRSAID,
                        '4'  AS IDTPLANCTO,
                        NULL AS IDALTCUSMED,
                        '9'  AS IDORDEMCLC,
                        '4'  AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ,
                        P.DTPROCESSA,
                        P.CDTIPCUSTEST
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NOT NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 5
                    AND UPPER(E.CODMTVBLQ) = 'QUARENTENA'
                    AND E.NOMTIPOPE = 'Sada'
                    AND E.FLAPRC = '0'

                  UNION ALL

                 /* Desbloqueio (Quarentena)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Desbloqueio de Estoque SAGA (Quarentena)' AS DSLANCESTQ,
                        E.CODMER,
                        ABS(E.VALQTD) VALQTD,
                        E.VALEMBSKU,
                        'E' AS IDENTRSAID,
                        '2' AS IDTPLANCTO,
                        'S' AS IDALTCUSMED,
                        '2' AS IDORDEMCLC,
                        '2' AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ,
                        P.DTPROCESSA,
                        P.CDTIPCUSTEST
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NOT NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 5
                    AND UPPER(E.CODMTVBLQ) = 'QUARENTENA'
                    AND E.NOMTIPOPE = 'Entrada'
                    AND E.FLAPRC = '0'
                  
                  UNION ALL
                  
                 /* Bloqueio (Avaria Parcial)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Bloqueio de Estoque SAGA (Avaria Parcial)' AS DSLANCESTQ,
                        E.CODMER,
                        ABS(E.VALQTD) VALQTD,
                        E.VALEMBSKU,
                        'S'  AS IDENTRSAID,
                        '4'  AS IDTPLANCTO,
                        NULL AS IDALTCUSMED,
                        '9'  AS IDORDEMCLC,
                        '4'  AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ,
                        P.DTPROCESSA,
                        P.CDTIPCUSTEST
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NOT NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 5
                    AND UPPER(E.CODMTVBLQ) = 'AVARIA PARCIAL'
                    AND E.NOMTIPOPE = 'Sada'
                    AND E.FLAPRC = '0'
                  
                  UNION ALL
                  
                 /* Desbloqueio (Avaria Parcial)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Desbloqueio de Estoque SAGA (Avaria Parcial)' AS DSLANCESTQ,
                        E.CODMER,
                        ABS(E.VALQTD) VALQTD,
                        E.VALEMBSKU,
                        'E' AS IDENTRSAID,
                        '2' AS IDTPLANCTO,
                        'S' AS IDALTCUSMED,
                        '2' AS IDORDEMCLC,
                        '2' AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ,
                        P.DTPROCESSA,
                        P.CDTIPCUSTEST
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NOT NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 5
                    AND UPPER(E.CODMTVBLQ) = 'AVARIA PARCIAL'
                    AND E.NOMTIPOPE = 'Entrada'
                    AND E.FLAPRC = '0'
                
                  UNION ALL
                
                 /* Bloqueio (Avaria Total)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Bloqueio de Estoque SAGA (Avaria Total)' AS DSLANCESTQ,
                        E.CODMER,
                        ABS(E.VALQTD) VALQTD,
                        E.VALEMBSKU,
                        'S'  AS IDENTRSAID,
                        '3'  AS IDTPLANCTO,
                        NULL AS IDALTCUSMED,
                        '9'  AS IDORDEMCLC,
                        '3'  AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ,
                        P.DTPROCESSA,
                        P.CDTIPCUSTEST
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NOT NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ IN (4,5)
                    --AND UPPER(E.CODMTVBLQ) = 'AVARIA TOTAL'
                    AND UPPER(E.CODMTVBLQ) = 'AVARIA'
                    AND E.NOMTIPOPE = 'Sada'
                    AND E.FLAPRC = '0'

                  UNION ALL
                 
                 /* Desbloqueio (Avaria Total)  */
                 /*SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Desbloqueio de Estoque SAGA (Avaria Total)' AS DSLANCESTQ,
                        E.CODMER,
                        E.VALQTD,
                        E.VALEMBSKU,
                        'E' AS IDENTRSAID,
                        '2' AS IDTPLANCTO,
                        'S' AS IDALTCUSMED,
                        '2' AS IDORDEMCLC,
                        '2' AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ IN (4,5)
                    --AND UPPER(E.CODMTVBLQ) = 'AVARIA TOTAL'
                    AND UPPER(E.CODMTVBLQ) = 'AVARIA'
                    AND E.NOMTIPOPE = 'Entrada'
                    AND E.FLAPRC = '0'
                  
                  UNION ALL*/
                 
                 /* Bloqueio (PERDA)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Bloqueio de Estoque SAGA (Perda)' AS DSLANCESTQ,
                        E.CODMER,
                        ABS(E.VALQTD) VALQTD,
                        E.VALEMBSKU,
                        'S'  AS IDENTRSAID,
                        '3'  AS IDTPLANCTO,
                        NULL AS IDALTCUSMED,
                        '9'  AS IDORDEMCLC,
                        '3'  AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ,
                        P.DTPROCESSA,
                        P.CDTIPCUSTEST
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NOT NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ IN (4,5)
                    AND UPPER(E.CODMTVBLQ) = 'PERDA'
                    AND E.NOMTIPOPE = 'Sada'
                    AND E.FLAPRC = '0'

                  UNION ALL
                 
                 /* Desbloqueio (PERDA)  */
                 /*SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Desbloqueio de Estoque SAGA (Perda)' AS DSLANCESTQ,
                        E.CODMER,
                        E.VALQTD,
                        E.VALEMBSKU,
                        'E' AS IDENTRSAID,
                        '2' AS IDTPLANCTO,
                        'S' AS IDALTCUSMED,
                        '2' AS IDORDEMCLC,
                        '2' AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ IN (4,5)
                    --AND UPPER(E.CODMTVBLQ) = 'AVARIA TOTAL'
                    AND UPPER(E.CODMTVBLQ) = 'PERDA'
                    AND E.NOMTIPOPE = 'Entrada'
                    AND E.FLAPRC = '0'
                  
                  UNION ALL*/
                 
                 /* Bloqueio (Shelf LIFE)  */
                 /*SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Inventrio de Estoque SAGA (Shelf Life)' AS DSLANCESTQ,
                        E.CODMER,
                        E.VALQTD,
                        E.VALEMBSKU,
                        'S'  AS IDENTRSAID,
                        '1'  AS IDTPLANCTO,
                        NULL AS IDALTCUSMED,
                        CASE NVL(TRIM(P.IDORDIMPLANT), 'P')
                           WHEN ('P') THEN 'O'
                           ELSE 'U'
                        END AS IDORDEMCLC,
                        '1'  AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NOT NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    --AND E.IDCTIPTRSESQ = 5
                    AND E.IDCTIPTRSESQ IN (4,5)
                    AND UPPER(E.CODMTVBLQ) = 'SHELF LIFE'
                    AND E.NOMTIPOPE = 'Sada'
                    AND E.FLAPRC = '0'
                  
                  UNION ALL*/
                
                 /* Manuteno (Sada)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Manuteno de Estoque SAGA (Sada)' AS DSLANCESTQ,
                        E.CODMER,
                        ABS(E.VALQTD) VALQTD,
                        E.VALEMBSKU,
                        'S'  AS IDENTRSAID,
                        '4'  AS IDTPLANCTO,
                        NULL AS IDALTCUSMED,
                        '9'  AS IDORDEMCLC,
                        '4'  AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ,
                        P.DTPROCESSA,
                        P.CDTIPCUSTEST
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NOT NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ IN (4,5)
                    AND UPPER(E.CODMTVBLQ) LIKE 'MANUTEN%'
                    AND E.NOMTIPOPE = 'Sada'
                    AND E.FLAPRC = '0'

                  UNION ALL
                
                 /* Manuteno (Entrada)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Manuteno de Estoque SAGA (Entrada)' AS DSLANCESTQ,
                        E.CODMER,
                        ABS(E.VALQTD) VALQTD,
                        E.VALEMBSKU,
                        'E' AS IDENTRSAID,
                        '2' AS IDTPLANCTO,
                        'S' AS IDALTCUSMED,
                        '2' AS IDORDEMCLC,
                        '2' AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ,
                        P.DTPROCESSA,
                        P.CDTIPCUSTEST
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NOT NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ IN (4,5)
                    AND UPPER(E.CODMTVBLQ) LIKE 'MANUTEN%'
                    AND E.NOMTIPOPE = 'Entrada'
                    AND E.FLAPRC = '0'

                  UNION ALL
                 
                 /* Bloqueio (Vencimento)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Bloqueio de Estoque SAGA (Vencimento)' AS DSLANCESTQ,
                        E.CODMER,
                        ABS(E.VALQTD) VALQTD,
                        E.VALEMBSKU,
                        'S'  AS IDENTRSAID,
                        '3'  AS IDTPLANCTO,
                        NULL AS IDALTCUSMED,
                        '9'  AS IDORDEMCLC,
                        '3'  AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ,
                        P.DTPROCESSA,
                        P.CDTIPCUSTEST
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NOT NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ IN (4,5)
                    AND UPPER(E.CODMTVBLQ) = 'VENCIMENTO'
                    AND E.NOMTIPOPE = 'Sada'
                    AND E.FLAPRC = '0'

                  --UNION ALL
                 
                 /* Desbloqueio (Vencimento)  */
                 /*SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Desbloqueio de Estoque SAGA (Vencimento)' AS DSLANCESTQ,
                        E.CODMER,
                        E.VALQTD,
                        E.VALEMBSKU,
                        'E' AS IDENTRSAID,
                        '2' AS IDTPLANCTO,
                        'S' AS IDALTCUSMED,
                        '2' AS IDORDEMCLC,
                        '2' AS IDTIPOMOVI,
                        E.NOMTIPOPE,
                        E.CODMTVBLQ
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE P.CDFILIALSAGA IS NOT NULL
                    AND P.CDOPERADORSAGA IS NOT NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ IN (4,5)
                    AND UPPER(E.CODMTVBLQ) = 'VENCIMENTO'
                    AND E.NOMTIPOPE = 'Entrada'
                    AND E.FLAPRC = '0'*/
                  
                  ORDER BY CDFILIAL, DATGRCTRSESQ, CODMTVBLQ, NOMTIPOPE)
   LOOP
      IF ((V_CDFILIMOVI <> C_MOV.CDFILIAL) OR (V_DTGRCTRSESQ <> C_MOV.DATGRCTRSESQ) OR (V_NOMTIPOPE <> C_MOV.NOMTIPOPE)
          OR (V_CODMTVBLQ <> C_MOV.CODMTVBLQ)) THEN
         IF (V_BOATUALESTOQ) THEN
            ATUALIZA_ESTOQUE(V_CDFILIMOVI, V_DTINICIAL, V_DTFINAL, V_CDFILIMOVI, V_NRLANCESTQ);
            COMMIT;
         ELSE
            -- CASO NENHUM ITEM SEJA INCLUIDO NA MOVIMENTAO SER EXECUTADO UM ROLLBACK DA LANCTOEST
            ROLLBACK;
         END IF;
         
         V_INSERE       := 0;
         V_CDFILIMOVI   := C_MOV.CDFILIAL;
         V_IDTPLANCTO   := C_MOV.IDTPLANCTO;
         V_IDALTCUSMED  := C_MOV.IDALTCUSMED;
         V_IDORDEMCLC   := C_MOV.IDORDEMCLC;
         V_DTGRCTRSESQ  := C_MOV.DATGRCTRSESQ;
         V_NOMTIPOPE    := C_MOV.NOMTIPOPE;
         V_IDTIPOMOVI   := C_MOV.IDTIPOMOVI;
         V_CODMTVBLQ    := C_MOV.CODMTVBLQ;
         V_BOATUALESTOQ := FALSE;
         V_DTPROCESSA   := NVL(C_MOV.DTPROCESSA, SYSDATE);
         V_CDTIPCUSTEST := NVL(C_MOV.CDTIPCUSTEST, '03');
         
         IF V_IDORDEMCLC = '9' THEN
            V_BOPOSESTDIA := TRUE;
         ELSE
            V_BOPOSESTDIA := FALSE;
         END IF;
         
         /*BEGIN
            SELECT DTPROCESSA
              INTO V_DATAPROC
              FROM PARAMFILIAL
             WHERE CDFILIAL = V_CDFILIMOVI;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_DATAPROC := SYSDATE;
         END;

         IF V_DTGRCTRSESQ < V_DATAPROC THEN
            V_DTINICIAL := V_DTGRCTRSESQ;
         ELSE
            V_DTINICIAL := V_DATAPROC;
         END IF;
         
         IF V_DTGRCTRSESQ > V_DATAPROC THEN
            V_DTFINAL := V_DTGRCTRSESQ;
         ELSE
            V_DTFINAL := V_DATAPROC;
         END IF;*/
         
         V_DTINICIAL := V_DTGRCTRSESQ;
         V_DTFINAL   := V_DTGRCTRSESQ;
         
         --V_IDTPLANCTO := '1'; Inventrio
         --V_IDTPLANCTO := '2'; Entrada
         --V_IDTPLANCTO := '3'; -- PARA RETIRADA DE ESTOQUE USAR ESSE VALOR
         --V_IDTPLANCTO := '4'; Sada
         /* Sequencial do produto */
         V_NRSEQITPROD := 1;
         
         NOVO_CODIGO_SC('LANCTOEST' || V_CDFILIMOVI, V_NRLANCESTQ);
         V_NRLANCESTQ := SUBSTR(V_NRLANCESTQ, -10);
         
         INSERT INTO LANCTOESTOQ
           (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, DSLANCESTQ, IDALTCUSMED,
            NRLANCTONF, CDFILIMOVI, CDOPERADOR,  CDALMOXARIFE,  CDLOCALESTOQ)
         VALUES
           (V_CDFILIMOVI, V_NRLANCESTQ, V_IDTPLANCTO, V_DTGRCTRSESQ, SUBSTR(C_MOV.DSLANCESTQ, 1, 60), V_IDALTCUSMED,
            NULL, V_CDFILIMOVI, C_MOV.CDOPERADORSAGA,  NULL,  NULL);
               
         IF V_IDTPLANCTO = '3' THEN
            -- RETIRADA DE ESTOQUE - PERDA POR VENCIMENTO
            -- CDSETOR -- DESCOBRIR O SETOR QUE SER USADO
            V_CDSETOR := '0009';
            NOVO_CODIGO_SC('RETIESTO' || V_CDFILIMOVI, V_RETIESTO);
            V_RETIESTO := SUBSTR(V_RETIESTO, -10);
            INSERT INTO RETIRADAESTO
              (CDFILIAL, NRRETEST, DTRETEST, DSRETEST, CDFILIALLAN,
               NRLANCESTQ, CDSETOR) --, CDSETOR
            VALUES
              (V_CDFILIMOVI, V_RETIESTO, V_DTGRCTRSESQ, SUBSTR(C_MOV.DSLANCESTQ, 1, 60), V_CDFILIMOVI,
               V_NRLANCESTQ, V_CDSETOR); --, :CDSETOR
         END IF;
      END IF;
      /* Verifica informaes do produto de estoque relacionado ao lanamento */
      BEGIN
         SELECT MAX(P.CDPRODESTO)--, MAX(P.CDPRODESTO), MAX(P.CDPRODESTO), MAX(C_MOV.VALQTD * NVL(P.VRFATOCONV,1))
           INTO V_CDPRODESTO --V_CDPRODUTO, V_CDPRODESTO, V_QTESTCONV
           FROM PRODUTO P
          WHERE P.CDARVPROD = C_MOV.CODMER;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            --V_CDPRODUTO := NULL; V_CDPRODESTO := NULL; V_QTESTCONV := 0;
            V_CDPRODESTO := NULL;
      END;
      V_CDPRODUTO := V_CDPRODESTO;
      V_QTESTCONV := C_MOV.VALQTD;
      
      SELECT NMPRODUTO
        INTO V_NMPRODUTO
        FROM PRODUTO
       WHERE CDARVPROD = C_MOV.CODMER;
      
      /* Retorna custo do produto em estoque */
      BEGIN
         SELECT NVL(MAX(CDALMOXARIFE), ' '), NVL(MAX(CDLOCALESTOQ), ' '), NVL(MAX(NRLOTEESTQ), ' '), NVL(MAX(NRSUBLOTE), ' '),
                MAX(VRESTOQDIA), MAX(VRESTOQBRUT), MAX(QTESTOQDIA), (MAX(VRESTOQDIA)/MAX(QTESTOQDIA))
           INTO V_CDALMOXARIFE, V_CDLOCALESTOQ, V_NRLOTEESTQ, V_NRSUBLOTE,
                V_VRESTOQDIA, V_VRESTOQBRUT, V_QTESTOQDIA, V_VRUNITITEM
           FROM POSESTDIA P
          WHERE P.CDFILIAL  = V_CDFILIMOVI
            AND P.CDPRODUTO = V_CDPRODESTO
            AND P.QTESTOQDIA <> 0
            AND P.DTPOSIESTQ = (SELECT MAX(DTPOSIESTQ)
                                  FROM POSESTDIA
                                 WHERE CDFILIAL = P.CDFILIAL
                                   AND CDALMOXARIFE = P.CDALMOXARIFE
                                   AND CDLOCALESTOQ = P.CDLOCALESTOQ
                                   AND NRLOTEESTQ = P.NRLOTEESTQ
                                   AND NRSUBLOTE = P.NRSUBLOTE
                                   AND CDPRODUTO = P.CDPRODUTO
                                   AND DTPOSIESTQ <= TO_DATE(V_DTGRCTRSESQ)+1);
         
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDALMOXARIFE := NULL; V_CDLOCALESTOQ := NULL; V_NRLOTEESTQ := NULL; V_NRSUBLOTE := NULL;
            V_VRESTOQDIA := 0; V_VRESTOQBRUT := 0;
      END;
      
      BEGIN
         SELECT P.VRFATOCONV, NVL(C.IDPRODMENSU, 'N') IDPRODMENSU
           INTO V_VRFATORSKU, V_IDPRODMENSU
           FROM PRODUTO P, CARACPRODSAGA C
          WHERE P.CDPRODESTO = V_CDPRODESTO
            AND P.CDPRODUTO  = C.CDPRODUTO
            AND C.IDUNIDPADRSAGA = 'S';
      EXCEPTION
         WHEN OTHERS THEN
            V_VRFATORSKU := 0;
            UPDATE INT_MOVTRSESQ
               SET FLAPRC = 2,
                   DATULTPRC = SYSDATE,
                   DSCERR = 'Produto '||C_MOV.CODMER||' - '||V_NMPRODUTO||' no possui unidade de medida padro cadastrado.'
             WHERE IDCSEQ = C_MOV.IDCSEQ;
      END;
            
      IF (V_VRFATORSKU > 0) THEN
      IF (V_NRLOTEESTQ IS NOT NULL) THEN
         IF (V_BOPOSESTDIA) THEN
            POSICAO_ESTOQUE(V_CDFILIMOVI, V_CDPRODESTO, TO_DATE(V_DTGRCTRSESQ), V_QTDEESTO, V_VALRESTO, V_VALRBRUT);
            
            V_QTESTCONV := (V_QTESTCONV*V_VRFATORSKU);
            
            IF (V_PRODUTOVALID = V_CDPRODUTO) THEN
               V_INSERE := V_INSERE + V_QTESTCONV;
            ELSE
               V_INSERE := 0;
            END IF;
            
            V_BOINSEREITEM := (V_QTESTCONV + V_INSERE <= V_QTDEESTO);
         ELSE
            V_BOINSEREITEM := TRUE;
         END IF;
         
         IF (V_BOINSEREITEM) THEN
            V_NRSEQITPROD := LPAD(TO_CHAR(V_NRSEQITPROD), 4, '0');

            IF UPPER(C_MOV.CODMTVBLQ) = 'AVARIA' THEN
               V_CDTIPORETI := '14';
            ELSIF UPPER(C_MOV.CODMTVBLQ) = 'VENCIMENTO' THEN
               V_CDTIPORETI := '15';
            ELSE
               V_CDTIPORETI := NULL;
            END IF;
            
            INSERT INTO ITLANCTOEST
               (CDFILIAL, NRLANCESTQ, NRSEQUITEM, IDTIPOMOVI,
                CDPRODUTO, QTTOTLANCTO,  VRUNILANCTO, VRTOTLANCTO,
                DTLANCMOVI, IDORDEMCLC, CDPRODMOVI, QTLANCTOEST,
                VRLANCTOBRUT, VRLANCTOEST, CDFILIMOVI, CDALMOXARIFE,
                CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDTIPORETI)
            VALUES
               (V_CDFILIMOVI, V_NRLANCESTQ, V_NRSEQITPROD, V_IDTIPOMOVI,
                V_CDPRODUTO, V_QTESTCONV, V_VRUNITITEM, V_VRUNITITEM*V_QTESTCONV,
                V_DTGRCTRSESQ, V_IDORDEMCLC, V_CDPRODESTO, V_QTESTCONV,
                (V_VRESTOQBRUT/V_QTESTOQDIA), V_VRUNITITEM, V_CDFILIMOVI, V_CDALMOXARIFE,
                V_CDLOCALESTOQ, V_NRLOTEESTQ, V_NRSUBLOTE, V_CDTIPORETI);
            
            UPDATE INT_MOVTRSESQ
               SET FLAPRC = 1,
                   DATULTPRC = SYSDATE
             WHERE IDCSEQ = C_MOV.IDCSEQ;
            
            V_INSERE       := V_QTESTCONV;
            V_PRODUTOVALID := V_CDPRODUTO;
            V_BOATUALESTOQ := TRUE;
            V_NRSEQITPROD  := V_NRSEQITPROD + 1;
         ELSE
            UPDATE INT_MOVTRSESQ
               SET FLAPRC = 2,
                   DATULTPRC = SYSDATE,
                   DSCERR = 'Quantidade insuficiente para o produto '||C_MOV.CODMER||' - '||V_NMPRODUTO||'. Quantidade atual: '||V_QTDEESTO||
                            ' - Quantidade a ser retirada: '||V_QTESTCONV
             WHERE IDCSEQ = C_MOV.IDCSEQ;
         END IF;
      ELSE
         UPDATE INT_MOVTRSESQ
            SET FLAPRC = 2,
                DATULTPRC = SYSDATE,
                DSCERR = 'Produto '||C_MOV.CODMER||' - '||V_NMPRODUTO||' no possui custo por nunca ter sido movimentado. Favor realizar uma implantao de estoque'
          WHERE IDCSEQ = C_MOV.IDCSEQ;
      END IF; -- V_NRLOTEESTQ IS NOT NULL
      END IF; -- V_VRFATORSKU > 0
   END LOOP;
   
   ATUALIZA_ESTOQUE(V_CDFILIMOVI, V_DTINICIAL, V_DTFINAL, V_CDFILIMOVI, V_NRLANCESTQ);
   COMMIT;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_MOVI_ESTOQUE_SAGA','5.45.XXX'); END;
/