function Exp0800_comissaoVendedorPeriodo_Controller(templateManager, General, ScreenService, Exp0800_comissaoVendedorPeriodo_Service, ZhFilterPreferences, ZHPromise) {
    
    var mensagens = {
        errorBloqueado: 'O mapa já esta bloqueado.',
        mapaBloqueado: 'Mapa bloqueado com sucesso!',
        errorDesbloqueado: 'O mapa já esta desbloqueado.',
        mapaDesbloqueado: 'Mapa desbloqueado com sucesso.',
        errorApurar: 'Desbloqueie o mapa antes de apurar.',
        apuradoSucesso: 'Mapa apurado com sucesso!',
        apuradoError: 'Erro ao apurar o mapa!',
        alertaMapas: 'Existem notas/contas com alerta. Deseja continuar?',
        notaOutroPeriodo: 'Esta nota já foi apurada em outro periodo.',
        contaOutroPeriodo: 'Esta conta já foi apurada em outro periodo.',
        errorContaPagar: 'Ocorreu um erro ao gerar a conta!',
        contaPagarExistente: 'Esse mapa já possui contas a pagar.',
        bloquearMapa: 'O Mapa precisa ser bloqueado. Deseja bloquear agora?',
        desbloquarMapa: 'O Mapa precisa ser bloqueado. Deseja bloquear agora?',
        salvoSucesso: 'Salvo com sucesso!',
        errorSalvar:  'Ocorreu um erro a salvar',
        errorSaveComissao: 'Existe uma ou mais contas a pagar relacionadas a este item. Não foi possivel alterar o valor da comissão.',
        bloqOperacao: 'Este mapa possui contas a pagar. Não foi possivel ',
        apurarComissao: 'Existem mapas de periodos anteriores desbloqueados as notas/contas não apuradas serão incluidas neste mapa. Deseja continuar? '
    };  
    
    this.startFiltering = function(widgetPedidos){
        
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widgetPedidos.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widgetPedidos));
        ZHPromise.all(promises).then(function(rowSetFilter){
        }.bind(this)); 
    };
    
    this.adicionar = function(widget) {
        var row = {
            CDVENDEDOR: widget.getParent().currentRow.CDVENDEDOR,
            CDFILICOMIS: widget.getParent().currentRow.CDFILICOMIS,
            NRMAPACOMIS: widget.getParent().currentRow.NRMAPACOMIS
        };
        Exp0800_comissaoVendedorPeriodo_Service.verificaContaPagar(row).then(function(success){
            if(success.dataset.mapacompag[0]) {
                //ScreenService.showMessage(mensagens.bloqOperacao.concat('adicionar.'));
                ScreenService.showMessage("Este mapa possui contas a pagar. Não foi possivel adicionar.");
            }
            else {
                General.widgetNewRow(widget);
            }
        });
    };
    
    this.setDATAATUAL = function(widget){
        if(templateManager.container.getWidget('contas_a_pagar').dataSource.data.length > 0){
            templateManager.container.getWidget('contas_a_pagar').dataSource.data[0].DATAATUAL = moment().format('DD/MM/YYYY hh:mm:ss');
        }
    };
    
    this.apurarComissao = function(widget) {
            if(widget.currentRow.IDBLOQMAPACOMIS === 'N') {
            var row = { INICIAL: widget.currentRow.DTINIPERIODO,
                        FINAL: widget.currentRow.DTFIMPERIODO,
                        VENDEDOR: widget.currentRow.CDVENDEDOR,
                        NRORG: widget.currentRow.NRORG,
                        CDFILIAL: widget.currentRow.CDFILICOMIS,
                        NRMAPACOMIS: widget.currentRow.NRMAPACOMIS
            };  
            
           Exp0800_comissaoVendedorPeriodo_Service.verificaMapasAnteriores(row).then(function(success){
                if(success.dataset.mapacomperiodo[0]) {
                    //ScreenService.confirmMessage(ScreenService.i18n(mensagens.apurarComissao), 'question', function (success) {
                    ScreenService.confirmMessage("Existem mapas de periodos anteriores desbloqueados as notas/contas não apuradas serão incluidas neste mapa. Deseja continuar?", 'question', function(success){    
                        row.MAPAOUTROPERIODO = 'S';
                        ScreenService.confirmMessage(ScreenService.i18n('Deletar notas/contas fora do período?'), 'question', function (success) {
                            row.excluiForaPeriodo = 'S';
                            Exp0800_comissaoVendedorPeriodo_Service.apurarComissao(row).then(function(success){
                                //ScreenService.showMessage(mensagens.apuradoSucesso);
                                ScreenService.showMessage("Mapa apurado com sucesso!");
                                ScreenService.closePopup();
                                widget.reload();
                            }.bind(this),
                            function(error) {
                                //ScreenService.showMessage(mensagens.apuradoError);
                                ScreenService.showMessage("Erro ao apurar o mapa!");
                            });
                        }.bind(this), 
                        function(error) {
                           row.excluiForaPeriodo = 'N';
                            Exp0800_comissaoVendedorPeriodo_Service.apurarComissao(row).then(function(success){
                                //ScreenService.showMessage(mensagens.apuradoSucesso);
                                ScreenService.showMessage("Mapa apurado com sucesso!");
                                ScreenService.closePopup();
                                widget.reload();
                                templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
                                
                            },
                            function(error) {
                                //ScreenService.showMessage(mensagens.apuradoError);
                                ScreenService.showMessage("Erro ao apurar o mapa!");
                            });
                        }.bind(this));
                    }.bind(this),
                    function(error) {
                            ScreenService.closePopup();
                    });
                } else {
                    row.MAPAOUTROPERIODO = 'N';
                    ScreenService.confirmMessage(ScreenService.i18n('Este mapa já possui detalhamento. Deseja apagar todo o detalhamento para geração de um novo?' ), 'question', function (success) {
                        row.excluiForaPeriodo = 'S';
                        Exp0800_comissaoVendedorPeriodo_Service.apurarComissao(row).then(function(success){
                            //ScreenService.showMessage(mensagens.apuradoSucesso);
                            ScreenService.showMessage("Mapa apurado com sucesso!");
                            ScreenService.closePopup();
                            // templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
                            widget.reload();
                        }.bind(this),
                        function(error) {
                            //ScreenService.showMessage(mensagens.apuradoError);
                            ScreenService.showMessage("Erro ao apurar o mapa!");
                        });
                    }.bind(this), 
                    function(error) {
                       row.excluiForaPeriodo = 'N';
                        /*Exp0800_comissaoVendedorPeriodo_Service.apurarComissao(row).then(function(success){
                            //ScreenService.showMessage(mensagens.apuradoSucesso);
                            ScreenService.showMessage("Mapa apurado com sucesso!");*/
                            ScreenService.closePopup();
                            widget.reload();
                            templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
                            
                        /*}.bind(this),
                        function(error) {
                            //ScreenService.showMessage(mensagens.apuradoError);
                            ScreenService.showMessage("Erro ao apurar o mapa!");
                        });*/
                	}.bind(this));
                }
    	  
           }.bind(this));
        }
        //else ScreenService.showMessage(mensagens.errorApurar);
        else ScreenService.showMessage("Desbloqueie o mapa antes de apurar.");
    };
    
    
    
    this.saveNota = function(widget) {
        
        if(!widget.currentRow.EDITCOMISSAO) {
            widget.currentRow.EDITCOMISSAO = false;
        }
        widget.currentRow.NRORG = widget.getParent().currentRow.NRORG;
        var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
		var row = Util.clone(widget.currentRow, ignoredKeys);

        Exp0800_comissaoVendedorPeriodo_Service.saveNota(row).then(function(success){
            if(success.dataset) {
                //ScreenService.showMessage(mensagens.notaOutroPeriodo);
                ScreenService.showMessage("Esta nota já foi apurada em outro periodo.");
            }
            ScreenService.goBack();
            //ScreenService.showMessage(mensagens.salvoSucesso).then(function(){
            ScreenService.showMessage("Salvo com sucesso!").then(function(){    
                widget.reload();
                templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
            }.bind(this));
        }.bind(this),
        function(error) {
            //ScreenService.showMessage(mensagens.errorSave);
            ScreenService.showMessage("Ocorreu um erro a salvar");
        });
        
       
    };
    
    this.saveConta = function(widget) {
        widget.currentRow.NRORG = widget.getParent().currentRow.NRORG;
        if(!widget.currentRow.EDITCOMISSAO) {
            widget.currentRow.EDITCOMISSAO = false;
        }
        var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
		var row = Util.clone(widget.currentRow, ignoredKeys);
        row.NEWROW = true;
        Exp0800_comissaoVendedorPeriodo_Service.saveConta(row).then(function(success){
             if(success.dataset) {
                //ScreenService.showMessage(mensagens.contaOutroPeriodo);
                ScreenService.showMessage("Esta conta já foi apurada em outro periodo.");
            }
            ScreenService.goBack();
            //ScreenService.showMessage(mensagens.salvoSucesso).then(function(){
              ScreenService.showMessage("Salvo com sucesso!").then(function(){
                widget.reload();
                templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
            }.bind(this));
        }.bind(this),
        function(error) {
            //ScreenService.showMessage(mensagens.errorSave);
            ScreenService.showMessage("Ocorreu um erro a salvar");
        });
    };
    
    this.verificaValorComissao = function(widget, boolean){
        var widgetComissao = templateManager.container.getWidget('comissao_do_vendedor_por_periodo');
        if(widgetComissao.currentRow.VRCOMISTOTAL == 0 && widgetComissao.currentRow.IDBLOQMAPACOMIS == 'N'){
            ScreenService.confirmMessage("O mapa apurado está zerado. Deseja prosseguir com o bloqueio do Mapa?", 'question', function (success) {
                this.situacaoMapa(widget, boolean);
            }.bind(this),
            function(error) {
            });
        }else{
            this.situacaoMapa(widget, boolean);
        }
    };
    
    this.situacaoMapa = function(widget, boolean) {
        var widgetAtiva = templateManager.container.getActiveWidget();
        // Quando boolean é true o mapa é bloqueado
        // Quando boolean é false o mapa é desbloqueado
        
        if(boolean) {
            //Verifica se o mapa já esta bloqueado 
            if(widget.currentRow.IDBLOQMAPACOMIS === 'S') {
                //ScreenService.showMessage(mensagens.errorBloqueado);
                ScreenService.showMessage("O mapa já esta bloqueado.");
                return 0;
            }
            else {
                
                var row = { 
                    VENDEDOR: widget.currentRow.CDVENDEDOR,
                    NRORG: widget.currentRow.NRORG,
                    CDFILIAL: widget.currentRow.CDFILICOMIS,
                    NRMAPACOMIS: widget.currentRow.NRMAPACOMIS
                };  
                Exp0800_comissaoVendedorPeriodo_Service.verificaAlertaMapas(row).then(function(response){
                    if(response.dataset.mapacomexp.ERRO === true)  {
                    	//ScreenService.confirmMessage(ScreenService.i18n(mensagens.alertaMapas), 'question', function (success) {
                    	ScreenService.confirmMessage("Existem notas/contas com alerta. Deseja continuar?", 'question', function (success) {
                    	    widget.currentRow.IDBLOQMAPACOMIS = 'S';
                	        General.saveCrud(widget).then(function(success){
                                widget.reload();
                                ScreenService.closePopup();
                                //ScreenService.showMessage(mensagens.mapaBloqueado);
                                ScreenService.showMessage("Mapa bloqueado com sucesso!");
                             });
                    	},
                    	function(error) {
                    	    ScreenService.closePopup();
                    	});
                    }
                    else {
                        widget.currentRow.IDBLOQMAPACOMIS = 'S';
                        General.saveCrud(widget).then(function(success){
                            if(widgetAtiva.name == 'contas_a_pagar'){
                                widget.deactivate();
                                widgetAtiva.activate();
                                widgetAtiva.reload();
                                ScreenService.showMessage("Mapa bloqueado com sucesso!");
                            }else{
                                widget.reload();
                                ScreenService.closePopup();
                                //ScreenService.showMessage(mensagens.mapaBloqueado);
                                ScreenService.showMessage("Mapa bloqueado com sucesso!");
                            }
                        });
                    }
                },
                function(error){
                    ScreenService.showMessage('Erro ao bloquear mapa');
                });
            }
            
        }
        else {
            //Verifica se o mapa já esta desbloqueado
            if(widget.currentRow.IDBLOQMAPACOMIS === 'N') {
                //ScreenService.showMessage(mensagens.errorDesbloqueado);
                ScreenService.showMessage("O mapa já esta desbloqueado.");
                return 0;
            }else{
                var filtro = [ 
                    {
        				"name": "P_CDVENDEDOR",
        				"operator": "=",
        				"value": widget.currentRow.CDVENDEDOR
                    },
                    {
        				"name": "P_CDFILICOMIS",
        				"operator": "=",
        				"value": widget.currentRow.CDFILICOMIS
                    },
                    {
        				"name": "P_NRMAPACOMIS",
        				"operator": "=",
        				"value": widget.currentRow.NRMAPACOMIS
                    }
                ]; 
                General.callRestEngine("ped_expedicao#/crud/contasPagar_comissao_periodo", "FilterData", filtro).then(function (sucesso) {
                    if(sucesso.dataset.contasPagar_comissao_periodo.length > 0){
                        var contasPagar = sucesso.dataset.contasPagar_comissao_periodo;
                        contasPagar.forEach(function (contas){
                            if(contas.IDSTATBPAG == 'B'){
                                ScreenService.showMessage("Operação Bloqueada! Existem contas a pagar já baixadas.");
                            }else{
                                ScreenService.showMessage("Operação bloqueada. Este mapa já possui conta a pagar.");
                            }
                        });
                        
                    } else{
                      widget.currentRow.IDBLOQMAPACOMIS = 'N';
                        General.saveCrud(widget).then(function(success){
                            templateManager.container.getActiveWidget().reload();
                            ScreenService.closePopup();
                            if(boolean) {
                                //ScreenService.showMessage(mensagens.mapaBloqueado);
                                ScreenService.showMessage("Mapa bloqueado com sucesso!");
                            }
                            //else ScreenService.showMessage(mensagens.mapaDesbloqueado);
                            else ScreenService.showMessage("Mapa desbloqueado com sucesso.");
                        
                         });  
                    }
                    
                });
            } 
            
        }
    };
    
    this.gerarContaPagar = function(widget) {
        var widgetComissao = templateManager.container.getWidget('comissao_do_vendedor_por_periodo');
         var row = { 
            VENDEDOR    : widget.getParent().currentRow.CDVENDEDOR,
            NRORG       : widget.getParent().currentRow.NRORG,
            CDFILIAL    : widget.getParent().currentRow.CDFILICOMIS,
            NRMAPACOMIS : widget.getParent().currentRow.NRMAPACOMIS,
            VRCONTAPAG  : widget.getParent().currentRow.VRCOMISTOTAL
        };
        
        if(widget.getParent().currentRow.IDBLOQMAPACOMIS === 'N') {
            //ScreenService.confirmMessage(ScreenService.i18n(mensagens.bloquearMapa), 'question', function (success) {
            if(widgetComissao.currentRow.VRCOMISTOTAL == 0){
               this.verificaValorComissao(widget.getParent(), true);
               if(widget.dataSource.data[0]) {
                    //ScreenService.showMessage(mensagens.contaPagarExistente);
                    ScreenService.showMessage("Esse mapa já possui contas a pagar.");
                }
                else {
                    if(widget.getParent().currentRow.IDBLOQMAPACOMIS === 'S' && !widget.dataSource.data[0]){
                        Exp0800_comissaoVendedorPeriodo_Service.gerarContaPagar(row).then(function(success) {
                            widget.reload();
                            
                        },
                        function(error) {
                            //ScreenService.showMessage(mensagens.errorContaPagar);
                            ScreenService.showMessage(error.error);
                        });
                    }
                }
            }else{
                ScreenService.confirmMessage("O Mapa precisa ser bloqueado. Deseja bloquear agora?", 'question', function(success) {
                    this.situacaoMapa(widget.getParent(), true);
                    if(widget.dataSource.data[0]) {
                        //ScreenService.showMessage(mensagens.contaPagarExistente);
                        ScreenService.showMessage("Esse mapa já possui contas a pagar.");
                }
                    else {
                        if(widget.getParent().currentRow.IDBLOQMAPACOMIS === 'S' && !widget.dataSource.data[0]){
                            Exp0800_comissaoVendedorPeriodo_Service.gerarContaPagar(row).then(function(success) {
                                widget.reload();
                                
                            },
                            function(error) {
                                //ScreenService.showMessage(mensagens.errorContaPagar);
                                ScreenService.showMessage(error.error);
                            });
                        }
                }  
                }.bind(this));   
            }
        }
        else {
            if(widget.dataSource.data[0]) {
                //ScreenService.showMessage(mensagens.contaPagarExistente);
                ScreenService.showMessage("Esse mapa já possui contas a pagar.");
            }
            else {
                Exp0800_comissaoVendedorPeriodo_Service.gerarContaPagar(row).then(function(success) {
                    widget.reload();
                },
                function(error) {
                    if(error.data.error !== "Fornecedor não possui tipo de conta cadastrada."){
                        //ScreenService.showMessage(mensagens.errorContaPagar);
                        ScreenService.showMessage(error.error);
                        
                    }else{
                        ScreenService.showMessage("Fornecedor não possui tipo de conta cadastrada.");
                    }
                });  
            }
        }
    };
    
    this.saveComissaoProduto = function(widget) {
        widget.currentRow.EDITCOMISSAO = true;
        widget.currentRow.NRORG        = widget.getParent().currentRow.NRORG;
        widget.currentRow.NRMAPACOMIS  = widget.getParent().currentRow.NRMAPACOMIS;
        widget.currentRow.VENDEDOR     = widget.getParent().currentRow.CDVENDEDOR;
        widget.currentRow.CDVENDEDOR   = widget.getParent().currentRow.CDVENDEDOR;
        widget.currentRow.CDFILIAL     = widget.getParent().currentRow.CDFILICOMIS;
        widget.currentRow.__is_new     = false;
        Exp0800_comissaoVendedorPeriodo_Service.saveComissaoProduto(widget.currentRow).then(function(success) {
            ScreenService.goBack();
            widget.reload();
            templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
            //ScreenService.showMessage(mensagens.salvoSucesso);
            ScreenService.showMessage("Salvo com sucesso!");
        }.bind(this), function(error) {
            //ScreenService.showMessage(mensagens.errorSaveComissao);
            ScreenService.showMessage("Existe uma ou mais contas a pagar relacionadas a este item. Não foi possivel alterar o valor da comissão.");
        });
    };
    
    this.editComissao = function(widget) {
         var row = {
            CDVENDEDOR: widget.getParent().currentRow.CDVENDEDOR,
            CDFILICOMIS: widget.getParent().currentRow.CDFILICOMIS,
            NRMAPACOMIS: widget.getParent().currentRow.NRMAPACOMIS
        };
        Exp0800_comissaoVendedorPeriodo_Service.verificaContaPagar(row).then(function(success){
            if(success.dataset.mapacompag[0]) {
                //ScreenService.showMessage(mensagens.bloqOperacao.concat('editar.'));
                ScreenService.showMessage("Este mapa possui contas a pagar. Não foi possivel editar.");
            }
            else {
                if(templateManager.container.getWidget('comissao_do_vendedor_por_periodo').currentRow.IDBLOQMAPACOMIS === 'S') {
                    //ScreenService.confirmMessage(ScreenService.i18n(mensagens.desbloquarMapa), 'question', function (success) {
                    ScreenService.confirmMessage("O Mapa precisa ser bloqueado. Deseja bloquear agora?", 'question', function (success) {
                        General.widgetEdit(widget);
                    });
                }
                else {
                    General.widgetEdit(widget);
                }
            }
        }.bind(this));
    };
    
    this.excluirMapa = function(widget) {
        var row = {
            CDVENDEDOR: widget.currentRow.CDVENDEDOR,
            CDFILICOMIS: widget.currentRow.CDFILICOMIS,
            NRMAPACOMIS: widget.currentRow.NRMAPACOMIS,
            NRORG: widget.currentRow.NRORG
        };
        Exp0800_comissaoVendedorPeriodo_Service.verificaContaPagar(row).then(function(success){
            if(success.dataset.mapacompag[0]) {
                //ScreenService.showMessage(mensagens.bloqOperacao.concat('excluir.'));
                ScreenService.showMessage("Este mapa possui contas a pagar. Não foi possivel excluir.");
            }
            else {
                 var row = { 
                    CDVENDEDOR    : widget.currentRow.CDVENDEDOR,
                    NRORG       : widget.currentRow.NRORG,
                    CDFILIAL    : widget.currentRow.CDFILIAL,
                    NRMAPACOMIS : widget.currentRow.NRMAPACOMIS,
                    CDFILICOMIS: widget.currentRow.CDFILICOMIS,
                    dataSourceName: 'mapacomperiodo'
                }; 
                Exp0800_comissaoVendedorPeriodo_Service.excluirMapa(row).then(function(success){
                    ScreenService.showMessage('Deletado com sucesso!');
                    ScreenService.goBack();
                    widget.reload();
                }.bind(this),
                function(error){
                    ScreenService.showMessage('Ocorreu um erro ao deletar');
                });
            }
        }.bind(this));
    };
    
    this.excluir = function(widget) {
        var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
		var row = Util.clone(widget.currentRow, ignoredKeys);
        Exp0800_comissaoVendedorPeriodo_Service.verificaContaPagar(row).then(function(success){

            if(success.dataset.mapacompag[0]) {
                //ScreenService.showMessage(mensagens.bloqOperacao.concat('excluir.'));
                ScreenService.showMessage("Este mapa possui contas a pagar. Não foi possivel excluir.");
            }    
            else {
                General.deleteCrud(widget).then(function(success){
                    templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
                }.bind(this));
            }
        }.bind(this));
    };
    
    this.controlaVisibilidade = function(widget){
        if(widget.getCheckedRows().length == 0){
            widget.getAction('RECALCULO_COMISSAO').isVisible = false;
        }else{
            widget.getAction('RECALCULO_COMISSAO').isVisible = true;
        }
	};
	
	this.recalculoComissao = function(){
	    var widget = templateManager.container.getWidget('comissao_do_vendedor_por_periodo');
	    var rows = widget.getCheckedRows();
	    var dataset = [];
	    var i = 0;
	    rows.forEach(function(row){
	        var dadosRow = {
	            CDFILIAL: row.CDFILICOMIS,
	            CDVENDEDOR: row.CDVENDEDOR,
	            DATAINICIAL: row.DTINIPERIODO,
	            DATAFINAL: row.DTFIMPERIODO
	        };
	        dataset[i] = dadosRow;
	        i++;
	    });
	    
	    Exp0800_comissaoVendedorPeriodo_Service.recalculoComissao(dataset).then(function(){
            widget.reload();
            widget.unSelectAll();
            ScreenService.showMessage("Comissão recalculada com sucesso.");
	    }.bind(this))
	    .catch(function(){
	        ScreenService.showMessage("Ocorreu um erro ao recalcular a comissao do vendedor.");
	    }.bind(this));
	};

    
    this.adicionarComissao = function(widget){
        var rows = widget.groupedData;
        var cdfilial = widget.appliedFilter.FILTER_ROW.CDFILICOMIS;
        var cdvendedor =  widget.appliedFilter.FILTER_ROW.CDVENDEDOR;
        var nmfilial = widget.appliedFilter.FILTER_ROW.NMFILIAL;
        var nmrazsocven = widget.appliedFilter.FILTER_ROW.NMRAZSOCVEN;
        var maiorDataFinal;
        
        
        function maiorData(row){
            if(maiorDataFinal){
                if(moment(maiorDataFinal, "DD/MM/YYYY") < moment(row.DTFIMPERIODO, "DD/MM/YYYY")){
                    maiorDataFinal = moment(row.DTFIMPERIODO, 'DD/MM/YYYY');
                }
            }else{
                maiorDataFinal = row.DTFIMPERIODO;
            }
        }
        
        if(rows){
            widget.newRow();
            rows.forEach(maiorData);
        
            widget.currentRow.CDFILICOMIS = cdfilial;
            widget.getField('CDFILICOMIS').setValue(cdfilial);
            widget.currentRow.NMFILIAL = nmfilial;
            widget.getField('NMFILIAL').setValue(nmfilial);

            widget.currentRow.CDVENDEDOR = cdvendedor;
            widget.getField('CDVENDEDOR').setValue(cdvendedor);
            widget.currentRow.NMRAZSOCVEN = nmrazsocven;
            widget.getField('NMRAZSOCVEN').setValue(nmrazsocven);
            
            widget.getField('NMRAZSOCVEN').readOnly = true;
            widget.getField('NMFILIAL').readOnly = true;
            
            if(maiorDataFinal){
                widget.currentRow.DTINIPERIODO = moment(maiorDataFinal, 'DD/MM/YYYY').add(1,'days').format('DD/MM/YYYY');    
            }
            
            widget.reload();
        }else{
            widget.newRow();
        }
        
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Exp0800_comissaoVendedorPeriodo_Controller', Exp0800_comissaoVendedorPeriodo_Controller);
});